Option Explicit
'**********************************************************************************************
' The MAPIMESSAGE structure holds information about a message
'**********************************************************************************************
Type MAPIMESSAGE
    Reserved As Long
    Subject As String
    NoteText As String
    MessageType As String
    DateReceived As String
    ConversationID As String
    Flags As Long
    RecipCount As Long
    FileCount As Long
End Type

'**********************************************************************************************
' The MAPIRECIP structure holds information about a message originator or recipient
'**********************************************************************************************
Type MAPIRECIP
    Reserved As Long
    RecipClass As Long
    Name As String
    Address As String
    EIDSize As Long
    EntryID As String
End Type

'**********************************************************************************************
' The MAPIFILE structure holds information about the file attachments
'**********************************************************************************************
Type MAPIFILE
    Reserved As Long
    Flags As Long
    Position As Long
    PathName As String
    FileName As String
    FileType As String
End Type

'**********************************************************************************************
' FUNCTION Declarations
'**********************************************************************************************
Declare Function MAPILogon Lib "MAPI.DLL" (ByVal UIParam&, ByVal User$, ByVal Password$, ByVal Flags&, ByVal Reserved&, Session&) As Long
Declare Function MAPILogoff Lib "MAPI.DLL" (ByVal Session&, ByVal UIParam&, ByVal Flags&, ByVal Reserved&) As Long
Declare Function MAPIDetails Lib "MAPI.DLL" (ByVal Session&, ByVal UIParam&, Recipient As MAPIRECIP, ByVal Flags&, ByVal Reserved&) As Long
Declare Function MAPIDeleteMail Lib "MAPI.DLL" (ByVal Session&, ByVal UIParam&, ByVal MsgID$, ByVal Flags&, ByVal Reserved&) As Long
Declare Function MAPISendDocuments Lib "MAPI.DLL" (ByVal UIParam&, ByVal DelimStr$, ByVal FilePaths$, ByVal FileNames$, ByVal Reserved&) As Long

Declare Function MAPIResolveName Lib "VBAMAPI.DLL" Alias "BMAPIResolveName" (ByVal Session&, ByVal UIParam&, ByVal UserName$, ByVal Flags&, ByVal Reserved&, Recipient As MAPIRECIP) As Long
Declare Function MAPIFindNext Lib "VBAMAPI.DLL" Alias "BMAPIFindNext" (ByVal Session&, ByVal UIParam&, MsgType$, SeedMsgID$, ByVal Flag&, ByVal Reserved&, MsgID$) As Long
Declare Function MAPIAddress Lib "VBAMAPI.DLL" Alias "BMAPIAddress" (ByVal Session&, ByVal UIParam&, Caption$, ByVal EditFields&, Label$, RecipCount&, Recipients() As MAPIRECIP, ByVal Flags&, ByVal Reserved&) As Long
Declare Function MAPISaveMail Lib "VBAMAPI.DLL" Alias "BMAPISaveMail" (ByVal Session&, ByVal UIParam&, Message As MAPIMESSAGE, Recipient As MAPIRECIP, File As MAPIFILE, ByVal Flags&, ByVal Reserved&, MsgID$) As Long
Declare Function MAPISendMail Lib "VBAMAPI.DLL" Alias "BMAPISendMail" (ByVal Session&, ByVal UIParam&, Message As MAPIMESSAGE, Recipient As MAPIRECIP, File As MAPIFILE, ByVal Flags&, ByVal Reserved&) As Long
Declare Function MAPIReadMail Lib "VBAMAPI.DLL" Alias "BMAPIReadMail" (ByVal Session&, ByVal UIParam&, ByVal MsgID$, ByVal Flags&, ByVal Reserved&, Message As MAPIMESSAGE, Originator As MAPIRECIP, recips() As MAPIRECIP, Files() As MAPIFILE) As Long

'**********************************************************************************************
' CONSTANT Declarations
'**********************************************************************************************
Global Const SUCCESS_SUCCESS = 0
Global Const MAPI_USER_ABORT = 1
Global Const MAPI_E_FAILURE = 2
Global Const MAPI_E_LOGIN_FAILURE = 3
Global Const MAPI_E_DISK_FULL = 4
Global Const MAPI_E_INSUFFICIENT_MEMORY = 5
Global Const MAPI_E_BLK_TOO_SMALL = 6
Global Const MAPI_E_TOO_MANY_SESSIONS = 8
Global Const MAPI_E_TOO_MANY_FILES = 9
Global Const MAPI_E_TOO_MANY_RECIPIENTS = 10
Global Const MAPI_E_ATTACHMENT_NOT_FOUND = 11
Global Const MAPI_E_ATTACHMENT_OPEN_FAILURE = 12
Global Const MAPI_E_ATTACHMENT_WRITE_FAILURE = 13
Global Const MAPI_E_UNKNOWN_RECIPIENT = 14
Global Const MAPI_E_BAD_RECIPTYPE = 15
Global Const MAPI_E_NO_MESSAGES = 16
Global Const MAPI_E_INVALID_MESSAGE = 17
Global Const MAPI_E_TEXT_TOO_LARGE = 18
Global Const MAPI_E_INVALID_SESSION = 19
Global Const MAPI_E_TYPE_NOT_SUPPORTED = 20
Global Const MAPI_E_AMBIGUOUS_RECIPIENT = 21
Global Const MAPI_E_MESSAGE_IN_USE = 22
Global Const MAPI_E_NETWORK_FAILURE = 23
Global Const MAPI_E_INVALID_EDITFIELDS = 24
Global Const MAPI_E_INVALID_RECIPS = 25
Global Const MAPI_E_NOT_SUPPORTED = 26

Global Const MAPI_ORIG = 0
Global Const MAPI_TO = 1
Global Const MAPI_CC = 2
Global Const MAPI_BCC = 3

Global Const MAPI_UNREAD = 1
Global Const MAPI_RECEIPT_REQUESTED = 2
Global Const MAPI_SENT = 4

'**********************************************************************************************
' FLAG Declarations
'**********************************************************************************************
Global Const MAPI_LOGON_UI = &h1
Global Const MAPI_NEW_SESSION = &h2
Global Const MAPI_DIALOG = &h8
Global Const MAPI_UNREAD_ONLY = &h20
Global Const MAPI_ENVELOPE_ONLY = &h40
Global Const MAPI_PEEK = &h80
Global Const MAPI_GUARANTEE_FIFO = &h100
Global Const MAPI_BODY_AS_FILE = &h200
Global Const MAPI_AB_NOMODIFY = &h400
Global Const MAPI_SUPPRESS_ATTACH = &h800
Global Const MAPI_FORCE_DOWNLOAD = &h1000

Global Const MAPI_OLE = &h1
Global Const MAPI_OLE_STATIC = &h2
