Attribute VB_Name = "LibTalkMail"
Option Explicit

'
' internal message pointer
Type MsgPtr
    ID As String
    Subject As String
End Type
'
' to track msgs
Public uMsgP() As MsgPtr
Public iMsgCount As Integer
Public cMsgID As String
'
' ole message libary objects
Public objSession As Object
Public objInBox As Object
Public objOutBox As Object
Public objMsgColl As Object
Public objAttach As Object
Public objAttachColl As Object
Public objRecipColl As Object
Public objRecip As Object
Public objMsg As Object
Public objAddrEntry As Object
'
' for MCI wav work
Public cWavFile As String
Public Const conInterval = 50
Public Const conIntervalPlus = 55


Public Sub MAPIStart()
    '
    ' log into mapi
    '
    On Error GoTo LocalErr
    '
    Set objSession = CreateObject("MAPI.Session")
    objSession.Logon
    '
    Set objInBox = objSession.Inbox
    Set objOutBox = objSession.Outbox
    Exit Sub
    '
LocalErr:
    MsgBox ErrMsg(Err), vbCritical, "MAPIStart"
    '
End Sub

Public Sub MAPIEnd()
    '
    On Error Resume Next
    '
    objSession.Logoff
    Set objSession = Nothing
    Set objInBox = Nothing
    Set objOutBox = Nothing
    Set objMsgColl = Nothing
    Set objRecip = Nothing
    Set objMsg = Nothing
    '
End Sub

Public Sub MAPIAddrBook()
    '
    On Error GoTo LocalErr
    '
    objSession.AddressBook
    Exit Sub
    '
LocalErr:
    MsgBox ErrMsg(Err), vbCritical, "MAPIAddrBook"
    '
End Sub

Public Function ErrMsg(ErrObj As Object) As String
    '
    ' return formatted message
    '
    Dim cMsg As String
    '
    cMsg = "ErrCode:" & Chr(9) & CStr(ErrObj.Number) & Chr(13)
    cMsg = cMsg & "ErrMsg:" & Chr(9) & ErrObj.Description & Chr(13)
    cMsg = cMsg & "Source:" & Chr(9) & ErrObj.Source
    '
    ErrMsg = cMsg
    '
End Function

Public Function FindSubject(cSubject As String) As String
    '
    ' takes subject line, returns MsgID
    '
    Dim x As Integer
    Dim cRtn As String
    '
    cRtn = "" ' start empty
    For x = 1 To iMsgCount
        If UCase(cSubject) = UCase(uMsgP(x).Subject) Then
            cRtn = uMsgP(x).ID
            Exit For
        End If
    Next x
    '
    FindSubject = cRtn
    '
End Function

Public Sub MAPINewMsg()
    '
    ' allow user to compose a message
    '
    frmTMView.CMDialog1.Filter = "WaveForm File (*.wav)|*.wav"
    frmTMNew.MMControl1.DeviceType = "WaveAudio"
    frmTMNew.Show
    frmTMView.Hide
    '
End Sub

Public Sub MAPISendMsg(objRecipList As Object, cSubject As String, cBody As String, cWavFile As String)
    '
    ' construct a message and send it off
    '
    On Error GoTo LocalErr
    '
    Dim x As Integer
    '
    ' build new message
    Set objMsg = objOutBox.Messages.Add
    objMsg.Type = "IPM.Note.TalkMail"
    objMsg.Subject = cSubject
    objMsg.Text = " " & cBody
    '
    ' add wav file as attachment
    If Len(cWavFile) <> 0 Then
        Set objAttach = objMsg.Attachments.Add
        objAttach.Name = "Talk Mail.WAV" 'cWavFile
        objAttach.position = 0
        objAttach.Type = mapiFileData
        objAttach.Source = cWavFile
        objAttach.ReadFromFile cWavFile
    End If
    '
    ' load recipient(s)
    If objRecipList Is Nothing Then
        MsgBox "No Recipients!"
    Else
        For x = 1 To objRecipList.Count
            Set objRecip = objMsg.Recipients.Add
            objRecip.Name = objRecipList.Item(x).Name
        Next x
    End If
    '
    ' send it out quietly
    On Error Resume Next
    objMsg.Update ' update all the collections
    objMsg.Send showdialog:=False
    '
    ' let everyone know
    MsgBox "Message Sent", vbInformation, "Talk Mail"
    '
    Exit Sub
    '
LocalErr:
    MsgBox ErrMsg(Err), vbCritical, "MAPISendMsg"
    '
End Sub

Public Sub MAPIReadMsg(cMsgID As String)
    '
    ' allow user to view a message
    '
    frmTMView.CMDialog1.Filter = "WaveForm File (*.wav)|*.wav"
    frmTMRead.MMControl1.DeviceType = "WaveAudio"
    frmTMRead.Show
    frmTMView.Hide
    '
End Sub

Public Function GetRecipients(objRecipColl As Object) As String
    '
    ' pull qualified recipients from object collection
    '
    Dim cRtn As String
    Dim x As Integer
    '
    cRtn = ""
    '
    If objRecipColl Is Nothing Then
        GoTo LeaveHere
    End If
    '
    For x = 1 To objRecipColl.Count
        Set objRecip = objRecipColl.Item(x)
        cRtn = cRtn & objRecip.Name & ";"
    Next x
    '
    If Len(cRtn) > 0 Then
        cRtn = Left(cRtn, Len(cRtn) - 1)
    End If
    '
LeaveHere:
    GetRecipients = cRtn
    '
End Function

Public Sub MAPIDeleteMsg(cMsgID As String)
    '
    ' delete selected message
    '
    On Error GoTo LocalErr
    '
    Dim iAns As Integer
    '
    Set objMsg = objSession.GetMessage(cMsgID)
    '
    iAns = MsgBox(objMsg.Subject, vbExclamation + vbYesNo, "Delete Talk Mail Message")
    If iAns = vbYes Then
        objMsg.Delete
    End If
    '
    Exit Sub
    '
LocalErr:
    MsgBox ErrMsg(Err), vbCritical, "MAPIDeleteMsg"
    '
End Sub
