Attribute VB_Name = "LibMEA"
Option Explicit
'
' APIs for read/write of shared INI settings
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
'
Global cRuleFile As String
Global cIsEqualTo As String
Global cIsContainedIn As String
Global cIsGreaterThan As String
Global cIsLessThan As String
Global cForwardMsg1 As String
Global cForwardMsg2 As String
Global lCounter As Long
'
' general section
Global cGeneralSection As String
Global cGeneralScanInterval As String
Global cScanIntervalValue As String
Global cGeneralAutoStart As String
Global cAutoStartValue As String
Global cGeneralEditor As String
Global cEditorValue As String
Global cGeneralLogFile As String
Global cLogFileValue As String
Global cGeneralLogFlag As String
Global cLogFlagValue As String
Global cGeneralRuleCount As String
Global cRuleCountValue As String
Global cGeneralTestCount As String
Global cTestCountValue As String
Global cGeneralActionCount As String
Global cActionCountValue As String
Global cGeneralProfile As String
Global cProfileValue As String
Global cGeneralDelFwdFlag As String
Global cDelFwdFlagValue As String
Global cGeneralDelReplyFlag As String
Global cDelReplyFlagValue As String
Global cGeneralNotifyDialog As String
Global cNotifyDialogValue As String
Global cGeneralMinOnStart As String
Global cMinOnStartValue As String
Global cGeneralLastUpdate As String
Global cLastUpdateValue As String
'
' test section
Global cTestSection As String
Global cTestPriority As String
Global cTestSubject As String
Global cTestSender As String
Global cTestCommands As String
'
' action section
Global cActionSection As String
Global cActionCopy As String ' COPY (folder)
Global cActionMove As String ' MOVE (folder)
Global cActionForward As String ' FORWARD (address)
Global cActionNotify As String ' NOTIFY
Global cActionReply As String ' REPLY (textfile)
Global cActionCommands As String
'
' rules section
Global cRulesSection As String
Global cRuleName() As String
Global cRuleTest() As String
Global cRuleAction() As String
Global cRuleCompare() As String
Global cTest() As String
Global cAction() As String
Global iTestCount As Integer
Global iActionCount As Integer
Global iRuleCount As Integer
'
' standard mapi objects
Global objSession As Object
Global objMsgColl As Object
Global objMessage As Object
Global objOriginator As Object
Global objRecipColl As Object
Global objRecipient As Object
Global objFolderColl As Object
Global objFolder As Object
Global objAddrEntry As Object
Global objInfoStoreColl As Object
Global objInfoStore As Object
Global objAttachColl As Object
Global objAttachments As Object

Public Sub Main()
    '
    ' main start and end
    '
    InitStuff
    frmMEA.Show vbModal
    CloseDown
    '
End Sub


Public Sub InitStuff()
    '
    ' it all starts here
    '
    ReDim cAction(0)
    ReDim cTest(0)
    ReDim cRuleName(0)
    ReDim cRuleTest(0)
    ReDim cRuleAction(0)
    ReDim cRuleCompare(0)
    '
    LoadStrings
    LoadValues
    StartMAPI
    LoadLists
    '
End Sub

Public Sub LoadStrings()
    '
    ' init all internals
    '
    cRuleFile = App.Path & "\" & App.EXEName & ".RUL"
    cIsEqualTo = "EQ"
    cIsContainedIn = "CI"
    cIsGreaterThan = "GT"
    cIsLessThan = "LT"
    '
    cGeneralSection = "General"
    cGeneralEditor = "Editor"
    cEditorValue = "notepad.exe"
    cGeneralLogFile = "LogFile"
    cLogFileValue = App.Path & "\" & App.EXEName & ".LOG"
    cGeneralLogFlag = "LogFlag"
    cLogFlagValue = "1"
    cGeneralScanInterval = "ScanInterval"
    cScanIntervalValue = "15"
    cGeneralRuleCount = "RuleCount"
    cRuleCountValue = "0"
    cGeneralTestCount = "TestCount"
    cTestCountValue = "0"
    cGeneralActionCount = "ActionCount"
    cActionCountValue = "0"
    cGeneralProfile = "Profile"
    cProfileValue = "MCA"
    cGeneralDelFwdFlag = "DeleteForwardFlag"
    cDelFwdFlagValue = "0"
    cGeneralNotifyDialog = "NotifyDialog"
    cNotifyDialogValue = "0"
    cGeneralDelReplyFlag = "DeleteReplyFlag"
    cDelReplyFlagValue = "0"
    cGeneralMinOnStart = "MinimzeOnStart"
    cMinOnStartValue = "0"
    cGeneralAutoStart = "AutoStart"
    cAutoStartValue = "0"
    cGeneralLastUpdate = "LastUpdated"
    cLastUpdateValue = Now()
    '
    cTestSection = "Tests"
    cTestPriority = "Priority"
    cTestSubject = "Subject"
    cTestSender = "Sender"
    cTestCommands = cTestPriority & " " & cTestSubject & " " & cTestSender
    '
    cActionSection = "Actions"
    cActionCopy = "Copy"
    cActionMove = "Move"
    cActionForward = "Forward"
    cActionReply = "Reply"
    cActionNotify = "Notify"
    cActionCommands = cActionCopy & " " & cActionMove & " " & cActionForward
    cActionCommands = cActionCommands & " " & cActionReply & " " & cActionNotify
    '
    cRulesSection = "Rules"
    '
End Sub

Public Sub LoadValues()
    '
    ' process rules file
    '
    INIGeneral "LOAD"
    INIRules "LOAD"
    INITests "LOAD"
    INIActions "LOAD"
    '
End Sub

Public Function LocalGetSetting(cFile As String, cSection As String, cKey As String, cDefault As String) As String
    '
    ' mimic GetSetting/SaveSetting for 32-bit text files
    '
    Dim lRtn As Long
    Dim lSize As Long
    Dim cTemp As String * 1024
    '
    lSize = Len(cTemp)
    lRtn = GetPrivateProfileString(cSection, cKey, cDefault, cTemp, lSize, cFile)
    If Trim(cTemp) = "" Then
        cTemp = Trim(cDefault)
        lRtn = WritePrivateProfileString(cSection, cKey, cTemp, cFile)
    End If
    '
    LocalGetSetting = Left(cTemp, lRtn)
    '
End Function

Public Sub INIGeneral(cAction As String)
    '
    ' load general rule stuff
    '
    cLastUpdateValue = Format(Now(), "general date")
    '
    cEditorValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralEditor, cEditorValue)
    cScanIntervalValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralScanInterval, cScanIntervalValue)
    cLogFileValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralLogFile, cLogFileValue)
    cLogFlagValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralLogFlag, cLogFlagValue)
    cRuleCountValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralRuleCount, cRuleCountValue)
    cActionCountValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralActionCount, cActionCountValue)
    cTestCountValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralTestCount, cTestCountValue)
    cProfileValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralProfile, cProfileValue)
    cDelFwdFlagValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralDelFwdFlag, cDelFwdFlagValue)
    cNotifyDialogValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralNotifyDialog, cNotifyDialogValue)
    cDelReplyFlagValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralDelReplyFlag, cDelReplyFlagValue)
    cMinOnStartValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralMinOnStart, cMinOnStartValue)
    cAutoStartValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralAutoStart, cAutoStartValue)
    cLastUpdateValue = INIRegSetting(cAction, cRuleFile, cGeneralSection, cGeneralLastUpdate, cLastUpdateValue)
    '
End Sub

Public Sub INIRules(cAction As String)
    '
    ' load all rules
    '
    Dim x As Integer
    '
    iRuleCount = Val(cRuleCountValue)
    ReDim Preserve cRuleName(iRuleCount)
    ReDim Preserve cRuleTest(iRuleCount)
    ReDim Preserve cRuleAction(iRuleCount)
    ReDim Preserve cRuleCompare(iRuleCount)
    '
    If iRuleCount > 0 Then
        For x = 0 To iRuleCount - 1
            cRuleName(x) = INIRegSetting(cAction, cRuleFile, cRulesSection, "RuleName" & CStr(x), cRuleName(x))
            cRuleTest(x) = INIRegSetting(cAction, cRuleFile, cRulesSection, "RuleTest" & CStr(x), cRuleTest(x))
            cRuleAction(x) = INIRegSetting(cAction, cRuleFile, cRulesSection, "RuleAction" & CStr(x), cRuleAction(x))
            cRuleCompare(x) = INIRegSetting(cAction, cRuleFile, cRulesSection, "RuleCompare" & CStr(x), cRuleCompare(x))
        Next x
    End If
    '
End Sub

Public Sub INITests(cAction As String)
    '
    ' load all tests
    '
    Dim x As Integer
    '
    iTestCount = Val(cTestCountValue)
    ReDim Preserve cTest(iTestCount)
    '
    If iTestCount > 0 Then
        For x = 0 To iTestCount - 1
            cTest(x) = INIRegSetting(cAction, cRuleFile, cTestSection, "Test" & CStr(x), cTest(x))
        Next x
    End If
    '
End Sub

Public Sub INIActions(cEvent As String)
    '
    ' load all actions
    '
    Dim x As Integer
    '
    iActionCount = Val(cActionCountValue)
    ReDim Preserve cAction(iActionCount)
    '
    If iActionCount > 0 Then
        For x = 0 To iActionCount - 1
            cAction(x) = INIRegSetting(cEvent, cRuleFile, cActionSection, "Action" & CStr(x), cAction(x))
        Next x
    End If
    '
End Sub

Public Sub StartMAPI()
    '
    ' log into mapi system
    '
    Set objSession = CreateObject("MAPI.Session")
    objSession.Logon profilename:=cProfileValue, profilepassword:="", newsession:=True
    '
End Sub

Public Sub MAPIEnd()
    '
    ' log off mapi system
    objSession.Logoff
    Set objSession = Nothing
    '
End Sub

Public Sub StartProcess()
    '
    ' start main process loop
    '
    Set objMsgColl = objSession.Inbox.Messages
    If objMsgColl Is Nothing Then
        MsgBox "No Messages to scan"
    Else
        ScanMsgs
        Set objMsgColl = Nothing
    End If
    '
End Sub

Public Sub CloseDown()
    '
    ' close dowm system
    '
    SaveValues
    MAPIEnd
    '
End Sub

Public Sub SaveValues()
    '
    ' save ini values for next time
    '
    INIGeneral "SAVE"
    INIRules "SAVE"
    INITests "SAVE"
    INIActions "SAVE"
    '
End Sub

Public Function LocalSaveSetting(cFile As String, cSection As String, cKey As String, cValue As String)
    '
    ' mimic INI/Registry stuff for public use
    '
    Dim lRtn As Long
    '
    lRtn = WritePrivateProfileString(cSection, cKey, cValue, cFile)
    LocalSaveSetting = cValue ' return what was saved
    '
End Function

Public Function INIRegSetting(cAction As String, cFile As String, cSection As String, cKey As String, cValue As String) As String
    '
    ' handle read/write of local ini settings
    ' for public use
    '
    INIRegSetting = ""
    '
    If UCase(cAction) = "LOAD" Then
        INIRegSetting = LocalGetSetting(cFile, cSection, cKey, cValue)
    End If
    '
    If UCase(cAction) = "SAVE" Then
        INIRegSetting = LocalSaveSetting(cFile, cSection, cKey, cValue)
    End If
    '
End Function

Public Sub FillList(cListName As String, lstControl As Control)
    '
    ' fill form lists with data
    '
    Dim x As Integer
    Dim ln As Integer
    Dim cLine As String
    '
    Select Case UCase(cListName)
        Case "RULES"
            lstControl.Clear
            For x = 0 To iRuleCount - 1
                If Len(cRuleName(x)) > 18 Then
                    ln = 18
                Else
                    ln = Len(cRuleName(x))
                End If
                cLine = Left(cRuleName(x), 18) & Space(20 - ln)
                '
                If Len(cRuleTest(x)) > 13 Then
                    ln = 13
                Else
                    ln = Len(cRuleTest(x))
                End If
                '
                cLine = cLine & Left(cRuleTest(x), 13) & Space(15 - ln)
                cLine = cLine & cRuleCompare(x)
                cLine = cLine & Space(2)
                cLine = cLine & cRuleAction(x)
                lstControl.AddItem cLine
            Next x
        Case "TESTS"
            lstControl.Clear
            For x = 0 To iTestCount - 1
                lstControl.AddItem cTest(x)
            Next x
        Case "ACTIONS"
            lstControl.Clear
            For x = 0 To iActionCount - 1
                lstControl.AddItem cAction(x)
            Next x
        Case "COMPARES"
            lstControl.Clear
            lstControl.AddItem cIsEqualTo
            lstControl.AddItem cIsGreaterThan
            lstControl.AddItem cIsLessThan
            lstControl.AddItem cIsContainedIn
    End Select
    '
End Sub

Public Function ParseWord(cLine As String) As String
    '
    ' pick a word off line
    '
    Dim nPos As Integer
    '
    nPos = InStr(cLine, " ")
    If nPos <> 0 Then
        ParseWord = Left(cLine, nPos - 1)
    Else
        ParseWord = ""
    End If
    '
End Function

Public Sub AddTest(cTestLine As String)
    '
    ' add a new test to system
    '
    Dim x As Integer
    Dim p As Integer
    '
    ' look for empty spot
    p = -1
    For x = 0 To iTestCount - 1
        If cTest(x) = "" Then
            p = x
            Exit For
        End If
    Next x
    '
    ' no empty spot, make a new one
    If p = -1 Then
        iTestCount = iTestCount + 1
        cTestCountValue = CStr(iTestCount)
        ReDim Preserve cTest(iTestCount)
        p = iTestCount - 1
    End If
    '
    cTest(p) = cTestLine ' save item
    '
    ' refresh lists
    SaveValues
    LoadValues
    LoadLists
    '
End Sub

Public Sub DeleteTest(itest As Integer)
    '
    ' remove test from list
    '
    cTest(itest) = ""
    '
    SaveValues
    LoadValues
    LoadLists
    '
End Sub

Public Sub DeleteAction(iAction As Integer)
    '
    ' remove action from list
    '
    cAction(iAction) = ""
    '
    SaveValues
    LoadValues
    LoadLists
    '
End Sub

Public Sub AddAction(cInput As String)
    '
    ' add a new test to system
    '
    Dim x As Integer
    Dim p As Integer
    '
    ' look for empty spot
    p = -1
    For x = 0 To iActionCount - 1
        If cAction(x) = "" Then
            p = x
            Exit For
        End If
    Next x
    '
    ' no empty spot, make a new one
    If p = -1 Then
        iActionCount = iActionCount + 1
        cActionCountValue = CStr(iActionCount)
        ReDim Preserve cAction(iActionCount)
        p = iActionCount - 1
    End If
    '
    cAction(p) = cInput ' save item
    '
    ' refresh lists
    SaveValues
    LoadValues
    LoadLists
    '
End Sub

Public Sub MakeRule(cName As String, cRule As String)
    '
    ' store new rule
    '
    Dim x As Integer
    Dim p As Integer
    Dim cTestPart As String
    Dim cComparePart As String
    Dim cActionPart As String
    Dim nPos1 As Integer
    Dim nPos2 As Integer
    '
    ' first get parts
    '
    nPos1 = 1
    nPos2 = InStr(nPos1, cRule, " | ")
    If nPos2 <> 0 Then
        cTestPart = Trim(Mid(cRule, nPos1, nPos2 - nPos1))
    End If
    '
    nPos1 = nPos2 + 3
    nPos2 = InStr(nPos1, cRule, " | ")
    If nPos2 <> 0 Then
        cComparePart = Trim(Mid(cRule, nPos1, nPos2 - nPos1))
    End If
    '
    nPos1 = nPos2 + 3
    cActionPart = Trim(Mid(cRule, nPos1, 255))
    '
    '
    ' look for empty spot
    p = -1
    For x = 0 To iRuleCount - 1
        If Trim(cRuleName(x)) = "" Then
            p = x
            Exit For
        End If
    Next x
    '
    ' no empty spot, make a new one
    If p = -1 Then
        iRuleCount = iRuleCount + 1
        cRuleCountValue = CStr(iRuleCount)
        ReDim Preserve cRuleName(iRuleCount)
        ReDim Preserve cRuleTest(iRuleCount)
        ReDim Preserve cRuleCompare(iRuleCount)
        ReDim Preserve cRuleAction(iRuleCount)
        p = iRuleCount - 1
    End If
    '
    ' save it
    cRuleName(p) = cName
    cRuleTest(p) = cTestPart
    cRuleCompare(p) = cComparePart
    cRuleAction(p) = cActionPart
    '
    ' refresh storage
    SaveValues
    LoadValues
    '
End Sub

Public Sub DeleteRule(iAction As Integer)
    '
    ' remove rule from list
    '
    cRuleName(iAction) = ""
    cRuleTest(iAction) = ""
    cRuleCompare(iAction) = ""
    cRuleAction(iAction) = ""
    '
    SaveValues
    LoadValues
    LoadLists
    '
End Sub

Public Sub AddRule()
    '
    ' handle adding new rule
    '
    frmMEARule.Show vbModal
    '
    frmMEA.MousePointer = vbHourglass
    '
    SaveValues
    LoadValues
    LoadLists
    '
    frmMEA.MousePointer = vbNormal
    '
End Sub

Public Sub ScanMsgs()
    '
    ' check each message for hits
    '
    Dim x As Long
    '
    Set objMessage = objMsgColl.GetFirst
    If objMessage Is Nothing Then
        Exit Sub ' no messages!
    End If
    Do Until objMessage Is Nothing
        CheckRule
        Set objMessage = objMsgColl.GetNext
    Loop
    '
    LogWrite "Msg Scan Completed"
    '
End Sub

Public Sub CheckRule()
    '
    ' check for rule hit
    '
    Dim x As Integer
    Dim cCmd As String
    Dim bRtn As Boolean
    Dim objAddrEntry As Object
    '
    On Error GoTo CheckRuleErr
    '
    For x = 0 To iRuleCount - 1
        cCmd = ParseWord(cRuleTest(x))
        '
        Select Case UCase(cCmd)
            Case UCase(cTestSender)
                Set objAddrEntry = objMessage.Sender
                If objAddrEntry Is Nothing Then
                    ' na
                Else
                    If CheckSender(x, objMessage.Sender.Name) = True Then
                        DoAction x
                    End If
                End If
            Case UCase(cTestSubject)
                If CheckSubject(x, objMessage.subject) = True Then
                    DoAction x
                End If
            Case UCase(cTestPriority)
                If CheckPriority(x, objMessage.importance) = True Then
                    DoAction x
                End If
        End Select
        '
    Next x
    '
    Exit Sub
    '
CheckRuleErr:
    MsgBox Error$, vbCritical, "CheckRuleErr [" & CStr(Err) & "]"
    '
End Sub

Public Function CheckSender(nRule As Integer, cName As String)
    '
    ' check name against sender test
    '
    Dim nPos As Integer
    Dim cSender As String
    '
    nPos = InStr(cRuleTest(nRule), " ")
    If nPos <> 0 Then
        cSender = Trim(Mid(cRuleTest(nRule), nPos + 1, 255))
    End If
    '
    cSender = Trim(UCase(cSender))
    cName = Trim(UCase(cName))
    '
    Select Case UCase(cRuleCompare(nRule))
        Case UCase(cIsEqualTo)
            If cSender = cName Then
                CheckSender = True
            Else
                CheckSender = False
            End If
        Case UCase(cIsGreaterThan)
            If cSender > cName Then
                CheckSender = True
            Else
                CheckSender = False
            End If
        Case UCase(cIsLessThan)
            If cSender < cName Then
                CheckSender = True
            Else
                CheckSender = False
            End If
        Case UCase(cIsContainedIn)
             If InStr(cSender, cName) <> 0 Then
                CheckSender = True
            Else
                CheckSender = False
            End If
    End Select
   '
End Function

Public Sub DoAction(nRule As Integer)
    '
    ' handle valid action
    ' nRule points to rule in array
    ' use current objMessage
    '
    Dim cCmd As String ' action command
    Dim cTarget As String ' action target
    Dim nPos As Integer
    '
    ' get command and target
    cCmd = ParseWord(cRuleAction(nRule))
    nPos = InStr(cRuleAction(nRule), " ")
    If nPos <> 0 Then
        cTarget = Trim(Mid(cRuleAction(nRule), nPos + 1, 255))
    End If
    '
    ' now execute command
    Select Case UCase(cCmd)
        Case UCase(cActionMove)
            MsgMoveCopy "MOVE", cTarget, objMessage
        Case UCase(cActionCopy)
            MsgMoveCopy "COPY", cTarget, objMessage
        Case UCase(cActionForward)
            MsgFwdReply "FORWARD", cTarget, objMessage
        Case UCase(cActionReply)
            MsgFwdReply "REPLY", cTarget, objMessage
        Case UCase(cActionNotify)
            MsgNotify cTarget, objMessage
    End Select
    '
End Sub

Public Sub MsgMoveCopy(cEvent As String, cFolder As String, objMsg As Object)
    '
    Dim objLocalFolder As Object
    Dim objLocalMsg As Object
    Dim objLocalRecipient As Object
    '
    Dim cMsg As String
    Dim cFldrID As String
    Dim cRecipName As String
    Dim cHeader As String
    Dim i As Integer
    '
    ' carry sender info with you
    cHeader = "<------ " & UCase(cEvent) & " from ["
    cHeader = cHeader & objMsg.Sender.Name
    cHeader = cHeader & "] by MAPI Email Agent ------>"
    cHeader = cHeader & Chr(13) & Chr(10) & Chr(13) & Chr(10)
    '
    ' look for folder
    cFldrID = FindFolder(cFolder)
    If cFldrID = "" Then
        Exit Sub
    End If
    '
    ' move to folder
    Set objLocalFolder = objSession.GetFolder(cFldrID)
    Set objLocalMsg = objLocalFolder.Messages.Add
    '
    ' copy from objmsg to objlocalmsg
    With objLocalMsg
        .DeliveryReceipt = objMsg.DeliveryReceipt
        .Encrypted = objMsg.Encrypted
        .importance = objMsg.importance
        .ReadReceipt = objMsg.ReadReceipt
        .Sent = objMsg.Sent
        .Signed = objMsg.Signed
        .subject = objMsg.subject
        .Submitted = objMsg.Submitted
        .Text = cHeader & objMsg.Text
        .TimeReceived = objMsg.TimeReceived
        .TimeSent = objMsg.TimeSent
        .Type = objMsg.Type
        .Unread = objMsg.Unread
    End With
    '
    ' add recipients
    For i = 1 To objMsg.Recipients.Count Step 1
        cRecipName = objMsg.Recipients.Item(i).Name
        If cRecipName <> "" Then
            Set objLocalRecipient = objLocalMsg.Recipients.Add
            objLocalRecipient.Name = cRecipName
        End If
    Next i
    '
    ' now save the update
    objLocalMsg.Update
    '
    ' if a move, dump the original message
    If UCase(cEvent) = "MOVE" Then
        objMsg.Delete
    End If
    '
    ' send out notices
    cMsg = UCase(cEvent) & " Message ["
    cMsg = cMsg & objMsg.subject
    cMsg = cMsg & "] to [" & cFolder & "]"
    LogWrite (cMsg)
    '
End Sub

Public Sub MsgFwdReply(cEvent As String, cDestAddr As String, objMsg As Object)
    '
    Dim cMsg As String
    '
    Dim objLocalMsgColl As Object
    Dim objCopyMsg As Object
    Dim cHeader As String
    Dim cSubjPrefix As String
    '
    cTarget = UCase(cEvent)
    '
    cHeader = "<------ Message " & cEvent
    cHeader = cHeader & " from ["
    cHeader = cHeader & objSession.Name
    cHeader = cHeader & "] by MAPI Email Agent ------>"
    cHeader = cHeader & Chr(13) & Chr(10) & Chr(13) & Chr(10)
    '
    If cEvent = "REPLY" Then
        cSubjPrefix = "RE: "
    Else
        cSubjPrefix = "FW: "
    End If
    '
    Set objLocalMsgColl = objSession.Outbox.Messages
    Set objCopyMsg = objLocalMsgColl.Add
    With objCopyMsg
        .subject = cSubjPrefix & objMsg.subject
        .Text = cHeader & objMsg.Text
    End With
    '
    ' add recipient
    Set objRecipient = objCopyMsg.Recipients.Add
    objRecipient.Name = cDestAddr
    objRecipient.Type = mapiTo
    objCopyMsg.Recipients.Resolve showdialog:=False
    objCopyMsg.Update
    objCopyMsg.Send showdialog:=False
    '
    ' delete old message?
    If cDelFwdFlagValue = "1" And cEvent = "FORWARD" Then
        objMessage.Delete
    End If
    If cDelReplyFlagValue = "1" And cEvent = "REPLY" Then
        objMessage.Delete
    End If
    objSession.Outbox.Update
    '
    ' send out status
    cMsg = cEvent & " Message ["
    cMsg = cMsg & objMsg.subject
    cMsg = cMsg & "] to [" & cDestAddr & "]"
    '
    LogWrite (cMsg)
    '
End Sub

Public Sub MsgNotify(cNotify As String, objMsg As Object)
    '
    Dim cMsg As String
    '
    cMsg = "Message Notification for ["
    cMsg = cMsg & objMsg.subject
    cMsg = cMsg & "] from ["
    cMsg = cMsg & objMsg.Sender.Name & "]"
    '
    ' send out pop-up?
    If cNotifyDialogValue = "1" Then
        MsgBox cMsg, vbExclamation, "MAPI Email Agent Notification"
    End If
    LogWrite (cMsg)
    '
End Sub

Public Sub LogWrite(cLine As String)
    '
    ' write an entry in the log
    '
    Dim nFile As Integer
    Dim cWriteLine As String
    '
    If cLogFlagValue <> "1" Then
        Exit Sub ' write is OFF
    End If
    '
    cWriteLine = Format(Now, "general date")
    cWriteLine = cWriteLine & Space(3)
    cWriteLine = cWriteLine & cLine
    '
    nFile = FreeFile
    Open cLogFileValue For Append As nFile
    Print #nFile, cWriteLine
    Close #nFile
    '
    frmMEA.lblstatus = cWriteLine
    '
End Sub

Public Sub LoadLists()
    '
    ' load the main form lists
    '
    FillList "rules", frmMEA.lstrules
    FillList "tests", frmMEA.lsttests
    FillList "actions", frmMEA.lstactions
    '
End Sub

Public Function FindFolder(cFldrName As String) As String
    '
    ' see if you can locate the requested folder
    ' if  found, return the unqiue Folder ID
    '
    Dim cRtnID As String
    Dim cTempID As String
    Dim objInfoStore As Object
    Dim objTempFldr As Object
    Dim objTempColl As Object
    Dim x As Integer
    '
    cRtnID = "" ' assume not found
    '
    ' scan the folder collection
    Set objTempColl = objSession.Inbox.Folders
    Set objTempFldr = objTempColl.GetFirst
    Do
        cTempID = objTempFldr.ID
        If UCase(objTempFldr.Name) = UCase(cFldrName) Then
            cRtnID = objTempFldr.ID
            Exit Do
        End If
        Set objTempFldr = objTempColl.GetNext
    Loop While objTempFldr.Name <> ""
    '
    FindFolder = cRtnID ' return the result
    '
End Function

Public Function CheckSubject(nRule As Integer, cSubjMsg As String) As Boolean
    '
    ' check subject against message test
    '
    Dim nPos As Integer
    Dim cSubjRule As String
    '
    nPos = InStr(cRuleTest(nRule), " ")
    If nPos <> 0 Then
        cSubjRule = Trim(Mid(cRuleTest(nRule), nPos + 1, 255))
    End If
    '
    cSubjRule = UCase(Trim(cSubjRule))
    cSubjMsg = UCase(Trim(cSubjMsg))
    '
    Select Case UCase(cRuleCompare(nRule))
        Case UCase(cIsEqualTo)
            If cSubjRule = cSubjMsg Then
                CheckSubject = True
            Else
                CheckSubject = False
            End If
        Case UCase(cIsLessThan)
            If cSubjRule < cSubjMsg Then
                CheckSubject = True
            Else
                CheckSubject = False
            End If
        Case UCase(cIsGreaterThan)
            If cSubjRule > cSubjMsg Then
                CheckSubject = True
            Else
                CheckSubject = False
            End If
        Case UCase(cIsContainedIn)
            If InStr(cSubjRule, cSubjMsg) <> 0 Then
                CheckSubject = True
            Else
                CheckSubject = False
            End If
    End Select
    '
End Function

Public Function CheckPriority(nRule As Integer, nImpMsg) As Boolean
    '
    ' check subject against message test
    '
    Dim nPos As Integer
    Dim cImpRule As String
    Dim nImpRule As Integer
    '
    nPos = InStr(cRuleTest(nRule), " ")
    If nPos <> 0 Then
        cImpRule = Trim(Mid(cRuleTest(nRule), nPos + 1, 255))
    End If
    '
    nImpRule = Val(cImpRule)
    '
    Select Case UCase(cRuleCompare(nRule))
        Case UCase(cIsEqualTo)
            If nImpRule = nImpMsg Then
                CheckPriority = True
            Else
                CheckPriority = False
            End If
        Case UCase(cIsLessThan)
            If nImpRule < nImpMsg Then
                CheckPriority = True
            Else
                CheckPriority = False
            End If
        Case UCase(cIsGreaterThan)
            If nImpRule > nImpMsg Then
                CheckPriority = True
            Else
                CheckPriority = False
            End If
    End Select
    '
End Function
