Attribute VB_Name = "modSpeech"
Option Explicit
'
' *********************************************
' This module adds SAPI support to the program.
' *********************************************

'
' VCmd speech stuff
Global objVCmd As Object ' SRCommand object
Global objVMenu As Object ' SRMenu object
Global cVCmdMenu() As String ' SR command strings
Global lSRCmd As Long ' SR command ID
'
' VTxt Speech stuff
Global objVText As Object ' TTS object
Global bVText As Boolean ' TTS flag
Global Const vTxtSpeak = 0
Global Const vTxtForward = 1
Global Const vTxtRewind = 2
Global Const vTxtStop = 3

Public Sub InitSAPI()
    '
    ' voice command objects
    Set objVCmd = CreateObject("Speech.VoiceCommand")
    objVCmd.Register "" ' use default location
    objVCmd.Awake = True ' awaken speech services
    Set objVMenu = objVCmd.MenuCreate(App.EXEName, "MDI", 1033, "", vcmdmc_CREATE_TEMP)
    InitVoice ' go build command list
    '
    ' voice text objects
    Set objVText = CreateObject("Speech.VoiceText")
    objVText.Register "", App.EXEName
    objVText.Enabled = True
    InitVText ' go build menu/buttons
    '
End Sub

Public Sub InitVoice()
    '
    ' build added voice menu commands
    '
    Dim x As Integer
    ReDim Preserve cVCmdMenu(11) As String
    '
    cVCmdMenu(1) = "New"
    cVCmdMenu(2) = "Open"
    cVCmdMenu(3) = "Exit"
    cVCmdMenu(4) = "Toggle Toolbar"
    cVCmdMenu(5) = "Read"
    cVCmdMenu(6) = "Forward"
    cVCmdMenu(7) = "Rewind"
    cVCmdMenu(8) = "Stop"
    cVCmdMenu(9) = "Cut"
    cVCmdMenu(10) = "Copy"
    cVCmdMenu(11) = "Paste"
    '
    For x = 1 To 11
        objVMenu.Add 100 + x, cVCmdMenu(x), "MDI Menu", cVCmdMenu(x)
    Next x
    objVMenu.Active = True
    '
    ' start timer loop
    frmMDI!SRTimer.Interval = 500 ' every 1/2 second
    frmMDI!SRTimer.Enabled = True ' turn it on
    '
End Sub

Public Sub VTextAction(Index As Integer)
    '
    ' handle request to start/stop reading
    '
    Static bVPause As Boolean
    '
    Screen.ActiveForm.MousePointer = vbHourglass
    '
    ' handle service request
    Select Case Index
        Case vTxtSpeak ' speak=0
            If Not bVText Then
                If Len(Trim(Screen.ActiveForm.Text1.Text)) <> 0 Then
                    objVText.Speak Screen.ActiveForm.Text1.Text, vtxtsp_NORMAL
                    bVText = True
                End If
            End If
        Case vTxtForward ' fast forward=1
            If bVText Then
                objVText.AudioFastForward
            End If
        Case vTxtRewind ' rewind=2
            If bVText Then
                objVText.AudioRewind
            End If
        Case vTxtStop ' stop speaking=3
            If bVText Then
                objVText.StopSpeaking
                bVText = False
                bVPause = False
            End If
    End Select
    '
    ' update menu
    If bVText Then
        With Screen.ActiveForm
            .mnuVText(0).Enabled = False
            .mnuVText(1).Visible = True
            .mnuVText(2).Visible = True
            .mnuVText(3).Visible = True
        End With
    Else
        If Screen.ActiveForm.Caption <> "MDI NotePad" Then
            With Screen.ActiveForm
                .mnuVText(0).Enabled = True
                .mnuVText(1).Visible = False
                .mnuVText(2).Visible = False
                .mnuVText(3).Visible = False
            End With
        End If
    End If
    '
    ' update buttons
    If bVText Then
        frmMDI.ImgVText(0).Visible = True
        frmMDI.ImgVText(1).Visible = True
        frmMDI.ImgVText(2).Visible = True
        frmMDI.ImgVText(3).Visible = True
    Else
        frmMDI.ImgVText(0).Visible = True
        frmMDI.ImgVText(1).Visible = False
        frmMDI.ImgVText(2).Visible = False
        frmMDI.ImgVText(3).Visible = False
    End If
    '
    ' no open text pages
    If Not AnyPadsLeft() Then
        frmMDI.ImgVText(0).Visible = False
    End If
    '
    Screen.ActiveForm.MousePointer = vbNormal
    '
End Sub

Public Sub InitVText()
    '
    ' set up vText buttons and menu
    '
    Dim cDir As String
    Dim cPic(4) As String
    Dim x As Integer
    '
    cDir = "d:\sams\cdg\chap20\mdi\"
    cPic(0) = "arw01rt.ico" ' read
    cPic(1) = "arw01up.ico" ' forward
    cPic(2) = "arw01lt.ico" ' rewind
    cPic(3) = "arw01dn.ico" ' stop
    '
    For x = 0 To 3
        frmMDI.ImgVText(x).Picture = LoadPicture(cDir & cPic(x))
    Next x
    '
    VTextAction vTxtStop ' force "stop"
    '
    ' start timer loop
    frmMDI.TTSTimer.Interval = 500 ' every 1/2 second
    frmMDI.TTSTimer.Enabled = True ' turn it on
    '
End Sub

Public Sub UnInitSAPI()
    '
    ' remove sapi services
    '
    objVMenu.Active = False ' stop menu
    Set objVMenu = Nothing  ' remove link
    objVCmd.Awake = False   ' close down SR
    Set objVCmd = Nothing   ' remove link
    '
    objVText.Enabled = False ' stop TTS
    Set objVText = Nothing  ' remove link
    '
End Sub
