Attribute VB_Name = "LibTapiLineDec"
Option Explicit

' **********************************************
' These structure, declares, and constants are
' used to complete support for the TAPILine OCX
' control. Currently the TAPILine control supports
' only LINE devices, but may support PHONE devices
' in the future.
' ************************************************

'
' DLL declares for TAPILine control
'
Declare Sub LineCallParamsFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINECALLPARAMS, ByVal ExtraData As String)
Declare Sub LineForwardListFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEFORWARDLIST, ByVal ExtraData As String)
Declare Sub LineGenerateToneFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEGENERATETONE_TYPE, ByVal ExtraData As String)
Declare Sub LineAddressCapsFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEADDRESSCAPS, ByVal ExtraData As String)
Declare Sub LineCallInfoFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINECALLINFO, ByVal ExtraData As String)
Declare Sub LineCallStatusFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINECALLSTATUS, ByVal ExtraData As String)
Declare Sub LineCallListFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINECALLLIST, ByVal ExtraData As String)
Declare Sub LineDevCapsFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEDEVCAPS, ByVal ExtraData As String)
Declare Sub VarStringFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As VARSTRING, ByVal ExtraData As String)
Declare Sub LineDevStatusFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEDEVSTATUS, ByVal ExtraData As String)
Declare Sub LineTranslateCapsFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINETRANSLATECAPS, ByVal ExtraData As String)
Declare Sub LineMonitorToneFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEMONITORTONE)
Declare Sub LineExtensionIDFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEEXTENSIONID)
Declare Sub LineDialParmsFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEDIALPARAMS)
Declare Sub LineMediaControlDigitFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEMEDIACONTROLDIGIT)
Declare Sub LineTranslateOutputFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINETRANSLATEOUTPUT, ByVal ExtraData As String)
Declare Sub LineAddressStatusFunc Lib "pstapidll32" (ByVal nMode As Long, structdata As LINEADDRESSSTATUS, ByVal ExtraData As String)

'
' constants for read/write of params
'
Global Const TAPI_WRITE = 0
Global Const TAPI_READ = 1

'
' ************************************************
' general TAPI constants
' ************************************************
'
Global Const TAPI_REPLY = &H400& + 99&
Global Const TAPIERR_CONNECTED = 0&
Global Const TAPIERR_DROPPED = -1&
Global Const TAPIERR_NOREQUESTRECIPIENT = -2&
Global Const TAPIERR_REQUESTQUEUEFULL = -3&
Global Const TAPIERR_INVALDESTADDRESS = -4&
Global Const TAPIERR_INVALWINDOWHANDLE = -5&
Global Const TAPIERR_INVALDEVICECLASS = -6&
Global Const TAPIERR_INVALDEVICEID = -7&
Global Const TAPIERR_DEVICECLASSUNAVAIL = -8&
Global Const TAPIERR_DEVICEIDUNAVAIL = -9&
Global Const TAPIERR_DEVICEINUSE = -10&
Global Const TAPIERR_DESTBUSY = -11&
Global Const TAPIERR_DESTNOANSWER = -12&
Global Const TAPIERR_DESTUNAVAIL = -13&
Global Const TAPIERR_UNKNOWNWINHANDLE = -14&
Global Const TAPIERR_UNKNOWNREQUESTID = -15&
Global Const TAPIERR_REQUESTFAILED = -16&
Global Const TAPIERR_REQUESTCANCELLED = -17&
Global Const TAPIERR_INVALPOINTER = -18&
Global Const TAPIMAXDESTADDRESSSIZE = 80&
Global Const TAPIMAXAPPNAMESIZE = 40&
Global Const TAPIMAXCALLEDPARTYSIZE = 40&
Global Const TAPIMAXCOMMENTSIZE = 80&
Global Const TAPIMAXDEVICECLASSSIZE = 40&
Global Const TAPIMAXDEVICEIDSIZE = 40&

'
' Line callback messages
'
Global Const LINE_ADDRESSSTATE = 0&
Global Const LINE_CALLINFO = 1&
Global Const LINE_CALLSTATE = 2&
Global Const LINE_CLOSE = 3&
Global Const LINE_DEVSPECIFIC = 4&
Global Const LINE_DEVSPECIFICFEATURE = 5&
Global Const LINE_GATHERDIGITS = 6&
Global Const LINE_GENERATE = 7&
Global Const LINE_LINEDEVSTATE = 8&
Global Const LINE_MONITORDIGITS = 9&
Global Const LINE_MONITORMEDIA = 10&
Global Const LINE_MONITORTONE = 11&
Global Const LINE_REPLY = 12&
Global Const LINE_REQUEST = 13&

'
' varstring is used by lots of TAPI calls
'
Global Const STRINGFORMAT_ASCII = &H1&
Global Const STRINGFORMAT_DBCS = &H2&
Global Const STRINGFORMAT_UNICODE = &H3&
Global Const STRINGFORMAT_BINARY = &H4&

Type VARSTRING
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwStringFormat As Long
    dwStringSize As Long
    dwStringOffset As Long
End Type
Global Const VARSTRING_FIXEDSIZE = 24

Type VARSTRING_STR
    Mem As String * VARSTRING_FIXEDSIZE
End Type

'
' **********************************************
' TAPI line device stuff
' **********************************************
'
Global Const LINEADDRCAPFLAGS_FWDNUMRINGS = &H1&
Global Const LINEADDRCAPFLAGS_PICKUPGROUPID = &H2&
Global Const LINEADDRCAPFLAGS_SECURE = &H4&
Global Const LINEADDRCAPFLAGS_BLOCKIDDEFAULT = &H8&
Global Const LINEADDRCAPFLAGS_BLOCKIDOVERRIDE = &H10&
Global Const LINEADDRCAPFLAGS_DIALED = &H20&
Global Const LINEADDRCAPFLAGS_ORIGOFFHOOK = &H40&
Global Const LINEADDRCAPFLAGS_DESTOFFHOOK = &H80&
Global Const LINEADDRCAPFLAGS_FWDCONSULT = &H100&
Global Const LINEADDRCAPFLAGS_SETUPCONFNULL = &H200&
Global Const LINEADDRCAPFLAGS_AUTORECONNECT = &H400&
Global Const LINEADDRCAPFLAGS_COMPLETIONID = &H800&
Global Const LINEADDRCAPFLAGS_TRANSFERHELD = &H1000&
Global Const LINEADDRCAPFLAGS_TRANSFERMAKE = &H2000&
Global Const LINEADDRCAPFLAGS_CONFERENCEHELD = &H4000&
Global Const LINEADDRCAPFLAGS_CONFERENCEMAKE = &H8000&
Global Const LINEADDRCAPFLAGS_PARTIALDIAL = &H10000
Global Const LINEADDRCAPFLAGS_FWDSTATUSVALID = &H20000
Global Const LINEADDRCAPFLAGS_FWDINTEXTADDR = &H40000
Global Const LINEADDRCAPFLAGS_FWDBUSYNAADDR = &H80000
Global Const LINEADDRCAPFLAGS_ACCEPTTOALERT = &H100000
Global Const LINEADDRCAPFLAGS_CONFDROP = &H200000
Global Const LINEADDRCAPFLAGS_PICKUPCALLWAIT = &H400000

Type LINEADDRESSCAPS
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwLineDeviceID As Long

    dwAddressSize As Long
    dwAddressOffset As Long

    dwDevSpecificSize As Long
    dwDevSpecificOffset As Long

    dwAddressSharing As Long
    dwAddressStates As Long
    dwCallInfoStates As Long
    dwCallerIDFlags As Long
    dwCalledIDFlags As Long
    dwConnectedIDFlags As Long
    dwRedirectionIDFlags As Long
    dwRedirectingIDFlags As Long
    dwCallStates As Long
    dwDialToneModes As Long
    dwBusyModes As Long
    dwSpecialInfo As Long
    dwDisconnectModes As Long

    dwMaxNumActiveCalls As Long
    dwMaxNumOnHoldCalls As Long
    dwMaxNumOnHoldPendingCalls As Long
    dwMaxNumConference As Long
    dwMaxNumTransConf As Long

    dwAddrCapFlags As Long
    dwCallFeatures As Long
    dwRemoveFromConfCaps As Long
    dwRemoveFromConfState As Long
    dwTransferModes As Long
    dwParkModes As Long

    dwForwardModes As Long
    dwMaxForwardEntries As Long
    dwMaxSpecificEntries As Long
    dwMinFwdNumRings As Long
    dwMaxFwdNumRings As Long

    dwMaxCallCompletions As Long
    dwCallCompletionConds As Long
    dwCallCompletionModes As Long
    dwNumCompletionMessages As Long
    dwCompletionMsgTextEntrySize As Long
    dwCompletionMsgTextSize As Long
    dwCompletionMsgTextOffset As Long
End Type
Global Const LINEADDRESSCAPS_FIXEDSIZE = 176

Type LINEADDRESSCAPS_STR
    Mem As String * LINEADDRESSCAPS_FIXEDSIZE
End Type

Global Const LINEADDRESSMODE_ADDRESSID = &H1&
Global Const LINEADDRESSMODE_DIALABLEADDR = &H2&

Global Const LINEADDRESSSHARING_PRIVATE = &H1&
Global Const LINEADDRESSSHARING_BRIDGEDEXCL = &H2&
Global Const LINEADDRESSSHARING_BRIDGEDNEW = &H4&
Global Const LINEADDRESSSHARING_BRIDGEDSHARED = &H8&
Global Const LINEADDRESSSHARING_MONITORED = &H10&

Global Const LINEADDRESSSTATE_OTHER = &H1&
Global Const LINEADDRESSSTATE_DEVSPECIFIC = &H2&
Global Const LINEADDRESSSTATE_INUSEZERO = &H4&
Global Const LINEADDRESSSTATE_INUSEONE = &H8&
Global Const LINEADDRESSSTATE_INUSEMANY = &H10&
Global Const LINEADDRESSSTATE_NUMCALLS = &H20&
Global Const LINEADDRESSSTATE_FORWARD = &H40&
Global Const LINEADDRESSSTATE_TERMINALS = &H80&

Type LINEADDRESSSTATUS
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwNumInUse As Long
    dwNumActiveCalls As Long
    dwNumOnHoldCalls As Long
    dwNumOnHoldPendCalls As Long
    dwAddressFeatures As Long

    dwNumRingsNoAnswer As Long
    dwForwardNumEntries As Long
    dwForwardSize As Long
    dwForwardOffset As Long

    dwTerminalModesSize As Long
    dwTerminalModesOffset As Long

    dwDevSpecificSize As Long
    dwDevSpecificOffset As Long
End Type
Global Const LINEADDRESSSTATUS_FIXEDSIZE = 64

Type LINEADDRESSSTATUS_STR
    Mem As String * LINEADDRESSSTATUS_FIXEDSIZE
End Type

Global Const LINEADDRFEATURE_FORWARD = &H1&
Global Const LINEADDRFEATURE_MAKECALL = &H2&
Global Const LINEADDRFEATURE_PICKUP = &H4&
Global Const LINEADDRFEATURE_SETMEDIACONTROL = &H8&
Global Const LINEADDRFEATURE_SETTERMINAL = &H10&
Global Const LINEADDRFEATURE_SETUPCONF = &H20&
Global Const LINEADDRFEATURE_UNCOMPLETECALL = &H40&
Global Const LINEADDRFEATURE_UNPARK = &H80&

Global Const LINEANSWERMODE_NONE = &H1&
Global Const LINEANSWERMODE_DROP = &H2&
Global Const LINEANSWERMODE_HOLD = &H4&

Global Const LINEBEARERMODE_VOICE = &H1&
Global Const LINEBEARERMODE_SPEECH = &H2&
Global Const LINEBEARERMODE_MULTIUSE = &H4&
Global Const LINEBEARERMODE_DATA = &H8&
Global Const LINEBEARERMODE_ALTSPEECHDATA = &H10&
Global Const LINEBEARERMODE_NONCALLSIGNALING = &H20&

Global Const LINEBUSYMODE_STATION = &H1&
Global Const LINEBUSYMODE_TRUNK = &H2&
Global Const LINEBUSYMODE_UNKNOWN = &H4&
Global Const LINEBUSYMODE_UNAVAIL = &H8&

Global Const LINECALLCOMPLCOND_BUSY = &H1&
Global Const LINECALLCOMPLCOND_NOANSWER = &H2&

Global Const LINECALLCOMPLMODE_CAMPON = &H1&
Global Const LINECALLCOMPLMODE_CALLBACK = &H2&
Global Const LINECALLCOMPLMODE_INTRUDE = &H4&
Global Const LINECALLCOMPLMODE_MESSAGE = &H8&

Global Const LINECALLFEATURE_ACCEPT = &H1&
Global Const LINECALLFEATURE_ADDTOCONF = &H2&
Global Const LINECALLFEATURE_ANSWER = &H4&
Global Const LINECALLFEATURE_BLINDTRANSFER = &H8&
Global Const LINECALLFEATURE_COMPLETECALL = &H10&
Global Const LINECALLFEATURE_COMPLETETRANSF = &H20&
Global Const LINECALLFEATURE_DIAL = &H40&
Global Const LINECALLFEATURE_DROP = &H80&
Global Const LINECALLFEATURE_GATHERDIGITS = &H100&
Global Const LINECALLFEATURE_GENERATEDIGITS = &H200&
Global Const LINECALLFEATURE_GENERATETONE = &H400&
Global Const LINECALLFEATURE_HOLD = &H800&
Global Const LINECALLFEATURE_MONITORDIGITS = &H1000&
Global Const LINECALLFEATURE_MONITORMEDIA = &H2000&
Global Const LINECALLFEATURE_MONITORTONES = &H4000&
Global Const LINECALLFEATURE_PARK = &H8000&
Global Const LINECALLFEATURE_PREPAREADDCONF = &H10000
Global Const LINECALLFEATURE_REDIRECT = &H20000
Global Const LINECALLFEATURE_REMOVEFROMCONF = &H40000
Global Const LINECALLFEATURE_SECURECALL = &H80000
Global Const LINECALLFEATURE_SENDUSERUSER = &H100000
Global Const LINECALLFEATURE_SETCALLPARAMS = &H200000
Global Const LINECALLFEATURE_SETMEDIACONTROL = &H400000
Global Const LINECALLFEATURE_SETTERMINAL = &H800000
Global Const LINECALLFEATURE_SETUPCONF = &H1000000
Global Const LINECALLFEATURE_SETUPTRANSFER = &H2000000
Global Const LINECALLFEATURE_SWAPHOLD = &H4000000
Global Const LINECALLFEATURE_UNHOLD = &H8000000

Type LINEDIALPARAMS
    dwDialPause As Long
    dwDialSpeed As Long
    dwDigitDuration As Long
    dwWaitForDialtone As Long
End Type
Global Const LINEDIALPARAMS_FIXEDSIZE = 16

Type LINEDIALPARAMS_STR
    Mem As String * LINEDIALPARAMS_FIXEDSIZE
End Type

Type LINECALLINFO
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    hLine As Long
    dwLineDeviceID As Long
    dwAddressID As Long

    dwBearerMode As Long
    dwRate As Long
    dwMediaMode As Long

    dwAppSpecific As Long
    dwCallID As Long
    dwRelatedCallID As Long
    dwCallParamFlags As Long
    dwCallStates As Long

    dwMonitorDigitModes As Long
    dwMonitorMediaModes As Long
    DialParams As LINEDIALPARAMS

    dwOrigin As Long
    dwReason As Long
    dwCompletionID As Long
    dwNumOwners As Long
    dwNumMonitors As Long

    dwCountryCode As Long
    dwTrunk As Long

    dwCallerIDFlags As Long
    dwCallerIDSize As Long
    dwCallerIDOffset As Long
    dwCallerIDNameSize As Long
    dwCallerIDNameOffset As Long

    dwCalledIDFlags As Long
    dwCalledIDSize As Long
    dwCalledIDOffset As Long
    dwCalledIDNameSize As Long
    dwCalledIDNameOffset As Long

    dwConnectedIDFlags As Long
    dwConnectedIDSize As Long
    dwConnectedIDOffset As Long
    dwConnectedIDNameSize As Long
    dwConnectedIDNameOffset As Long

    dwRedirectionIDFlags As Long
    dwRedirectionIDSize As Long
    dwRedirectionIDOffset As Long
    dwRedirectionIDNameSize As Long
    dwRedirectionIDNameOffset As Long

    dwRedirectingIDFlags As Long
    dwRedirectingIDSize As Long
    dwRedirectingIDOffset As Long
    dwRedirectingIDNameSize As Long
    dwRedirectingIDNameOffset As Long

    dwAppNameSize As Long
    dwAppNameOffset As Long

    dwDisplayableAddressSize As Long
    dwDisplayableAddressOffset As Long

    dwCalledPartySize As Long
    dwCalledPartyOffset As Long

    dwCommentSize As Long
    dwCommentOffset As Long

    dwDisplaySize As Long
    dwDisplayOffset As Long

    dwUserUserInfoSize As Long
    dwUserUserInfoOffset As Long

    dwHighLevelCompSize As Long
    dwHighLevelCompOffset As Long

    dwLowLevelCompSize As Long
    dwLowLevelCompOffset As Long

    dwChargingInfoSize As Long
    dwChargingInfoOffset As Long

    dwTerminalModesSize As Long
    dwTerminalModesOffset As Long

    dwDevSpecificSize As Long
    dwDevSpecificOffset As Long
End Type
Global Const LINECALLINFO_FIXEDSIZE = 296

Type LINECALLINFO_STR
    Mem As String * LINECALLINFO_FIXEDSIZE
End Type

Global Const LINECALLINFOSTATE_OTHER = &H1&
Global Const LINECALLINFOSTATE_DEVSPECIFIC = &H2&
Global Const LINECALLINFOSTATE_BEARERMODE = &H4&
Global Const LINECALLINFOSTATE_RATE = &H8&
Global Const LINECALLINFOSTATE_MEDIAMODE = &H10&
Global Const LINECALLINFOSTATE_APPSPECIFIC = &H20&
Global Const LINECALLINFOSTATE_CALLID = &H40&
Global Const LINECALLINFOSTATE_RELATEDCALLID = &H80&
Global Const LINECALLINFOSTATE_ORIGIN = &H100&
Global Const LINECALLINFOSTATE_REASON = &H200&
Global Const LINECALLINFOSTATE_COMPLETIONID = &H400&
Global Const LINECALLINFOSTATE_NUMOWNERINCR = &H800&
Global Const LINECALLINFOSTATE_NUMOWNERDECR = &H1000&
Global Const LINECALLINFOSTATE_NUMMONITORS = &H2000&
Global Const LINECALLINFOSTATE_TRUNK = &H4000&
Global Const LINECALLINFOSTATE_CALLERID = &H8000&
Global Const LINECALLINFOSTATE_CALLEDID = &H10000
Global Const LINECALLINFOSTATE_CONNECTEDID = &H20000
Global Const LINECALLINFOSTATE_REDIRECTIONID = &H40000
Global Const LINECALLINFOSTATE_REDIRECTINGID = &H80000
Global Const LINECALLINFOSTATE_DISPLAY = &H100000
Global Const LINECALLINFOSTATE_USERUSERINFO = &H200000
Global Const LINECALLINFOSTATE_HIGHLEVELCOMP = &H400000
Global Const LINECALLINFOSTATE_LOWLEVELCOMP = &H800000
Global Const LINECALLINFOSTATE_CHARGINGINFO = &H1000000
Global Const LINECALLINFOSTATE_TERMINAL = &H2000000
Global Const LINECALLINFOSTATE_DIALPARAMS = &H4000000
Global Const LINECALLINFOSTATE_MONITORMODES = &H8000000

Type LINECALLLIST
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwCallsNumEntries As Long
    dwCallsSize As Long
    dwCallsOffset As Long
End Type
Global Const LINECALLLIST_FIXEDSIZE = 24

Type LINECALLLIST_STR
    Mem As String * LINECALLLIST_FIXEDSIZE
End Type

Global Const LINECALLORIGIN_OUTBOUND = &H1&
Global Const LINECALLORIGIN_INTERNAL = &H2&
Global Const LINECALLORIGIN_EXTERNAL = &H4&
Global Const LINECALLORIGIN_UNKNOWN = &H10&
Global Const LINECALLORIGIN_UNAVAIL = &H20&
Global Const LINECALLORIGIN_CONFERENCE = &H40&

Global Const LINECALLPARAMFLAGS_SECURE = &H1&
Global Const LINECALLPARAMFLAGS_IDLE = &H2&
Global Const LINECALLPARAMFLAGS_BLOCKID = &H4&
Global Const LINECALLPARAMFLAGS_ORIGOFFHOOK = &H8&
Global Const LINECALLPARAMFLAGS_DESTOFFHOOK = &H10&

Type LINECALLPARAMS
    dwTotalSize As Long

    dwBearerMode As Long
    dwMinRate As Long
    dwMaxRate As Long
    dwMediaMode As Long

    dwCallParamFlags As Long
    dwAddressMode As Long
    dwAddressID As Long

    DialParams As LINEDIALPARAMS

    dwOrigAddressSize As Long
    dwOrigAddressOffset As Long

    dwDisplayableAddressSize As Long
    dwDisplayableAddressOffset As Long

    dwCalledPartySize As Long
    dwCalledPartyOffset As Long

    dwCommentSize As Long
    dwCommentOffset As Long

    dwUserUserInfoSize As Long
    dwUserUserInfoOffset As Long

    dwHighLevelCompSize As Long
    dwHighLevelCompOffset As Long

    dwLowLevelCompSize As Long
    dwLowLevelCompOffset As Long

    dwDevSpecificSize As Long
    dwDevSpecificOffset As Long
End Type
Global Const LINECALLPARAMS_FIXEDSIZE = 112

Type LINECALLPARAMS_STR
    Mem As String * LINECALLPARAMS_FIXEDSIZE
End Type

Global Const LINECALLPARTYID_BLOCKED = &H1&
Global Const LINECALLPARTYID_OUTOFAREA = &H2&
Global Const LINECALLPARTYID_NAME = &H4&
Global Const LINECALLPARTYID_ADDRESS = &H8&
Global Const LINECALLPARTYID_PARTIAL = &H10&
Global Const LINECALLPARTYID_UNKNOWN = &H20&
Global Const LINECALLPARTYID_UNAVAIL = &H40&

Global Const LINECALLPRIVILEGE_NONE = &H1&
Global Const LINECALLPRIVILEGE_MONITOR = &H2&
Global Const LINECALLPRIVILEGE_OWNER = &H4&

Global Const LINECALLREASON_DIRECT = &H1&
Global Const LINECALLREASON_FWDBUSY = &H2&
Global Const LINECALLREASON_FWDNOANSWER = &H4&
Global Const LINECALLREASON_FWDUNCOND = &H8&
Global Const LINECALLREASON_PICKUP = &H10&
Global Const LINECALLREASON_UNPARK = &H20&
Global Const LINECALLREASON_REDIRECT = &H40&
Global Const LINECALLREASON_CALLCOMPLETION = &H80&
Global Const LINECALLREASON_TRANSFER = &H100&
Global Const LINECALLREASON_REMINDER = &H200&
Global Const LINECALLREASON_UNKNOWN = &H400&
Global Const LINECALLREASON_UNAVAIL = &H800&

Global Const LINECALLSELECT_LINE = &H1&
Global Const LINECALLSELECT_ADDRESS = &H2&
Global Const LINECALLSELECT_CALL = &H4&

Global Const LINECALLSTATE_IDLE = &H1&
Global Const LINECALLSTATE_OFFERING = &H2&
Global Const LINECALLSTATE_ACCEPTED = &H4&
Global Const LINECALLSTATE_DIALTONE = &H8&
Global Const LINECALLSTATE_DIALING = &H10&
Global Const LINECALLSTATE_RINGBACK = &H20&
Global Const LINECALLSTATE_BUSY = &H40&
Global Const LINECALLSTATE_SPECIALINFO = &H80&
Global Const LINECALLSTATE_CONNECTED = &H100&
Global Const LINECALLSTATE_PROCEEDING = &H200&
Global Const LINECALLSTATE_ONHOLD = &H400&
Global Const LINECALLSTATE_CONFERENCED = &H800&
Global Const LINECALLSTATE_ONHOLDPENDCONF = &H1000&
Global Const LINECALLSTATE_ONHOLDPENDTRANSFER = &H2000&
Global Const LINECALLSTATE_DISCONNECTED = &H4000&
Global Const LINECALLSTATE_UNKNOWN = &H8000&

Type LINECALLSTATUS
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwCallState As Long
    dwCallStateMode As Long
    dwCallPrivilege As Long
    dwCallFeatures As Long

    dwDevSpecificSize As Long
    dwDevSpecificOffset As Long
End Type
Global Const LINECALLSTATUS_FIXEDSIZE = 36

Type LINECALLSTATUS_STR
    Mem As String * LINECALLSTATUS_FIXEDSIZE
End Type

Global Const LINEDEVCAPFLAGS_CROSSADDRCONF = &H1&
Global Const LINEDEVCAPFLAGS_HIGHLEVCOMP = &H2&
Global Const LINEDEVCAPFLAGS_LOWLEVCOMP = &H4&
Global Const LINEDEVCAPFLAGS_MEDIACONTROL = &H8&
Global Const LINEDEVCAPFLAGS_MULTIPLEADDR = &H10&
Global Const LINEDEVCAPFLAGS_CLOSEDROP = &H20&
Global Const LINEDEVCAPFLAGS_DIALBILLING = &H40&
Global Const LINEDEVCAPFLAGS_DIALQUIET = &H80&
Global Const LINEDEVCAPFLAGS_DIALDIALTONE = &H100&

Type LINEEXTENSIONID
    dwExtensionID0 As Long
    dwExtensionID1 As Long
    dwExtensionID2 As Long
    dwExtensionID3 As Long
End Type
Global Const LINEEXTENSIONID_FIXEDSIZE = 16

Type LINEEXTENSIONID_STR
    Mem As String * LINEEXTENSIONID_FIXEDSIZE
End Type

Type LINEDEVCAPS
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwProviderInfoSize As Long
    dwProviderInfoOffset As Long

    dwSwitchInfoSize As Long
    dwSwitchInfoOffset As Long

    dwPermanentLineID As Long
    dwLineNameSize As Long
    dwLineNameOffset As Long
    dwStringFormat As Long

    dwAddressModes As Long
    dwNumAddresses As Long
    dwBearerModes As Long
    dwMaxRate As Long
    dwMediaModes As Long

    dwGenerateToneModes As Long
    dwGenerateToneMaxNumFreq As Long
    dwGenerateDigitModes As Long
    dwMonitorToneMaxNumFreq As Long
    dwMonitorToneMaxNumEntries As Long
    dwMonitorDigitModes As Long
    dwGatherDigitsMinTimeout As Long
    dwGatherDigitsMaxTimeout As Long

    dwMedCtlDigitMaxListSize As Long
    dwMedCtlMediaMaxListSize As Long
    dwMedCtlToneMaxListSize As Long
    dwMedCtlCallStateMaxListSize As Long

    dwDevCapFlags As Long
    dwMaxNumActiveCalls As Long
    dwAnswerMode As Long
    dwRingModes As Long
    dwLineStates As Long

    dwUUIAcceptSize As Long
    dwUUIAnswerSize As Long
    dwUUIMakeCallSize As Long
    dwUUIDropSize As Long
    dwUUISendUserUserInfoSize As Long
    dwUUICallInfoSize As Long

    MinDialParams As LINEDIALPARAMS
    MaxDialParams As LINEDIALPARAMS
    DefaultDialParams As LINEDIALPARAMS

    dwNumTerminals As Long
    dwTerminalCapsSize As Long
    dwTerminalCapsOffset As Long
    dwTerminalTextEntrySize As Long
    dwTerminalTextSize As Long
    dwTerminalTextOffset As Long

    dwDevSpecificSize As Long
    dwDevSpecificOffset As Long
End Type
Global Const LINEDEVCAPS_FIXEDSIZE = 236

Type LINEDEVCAPS_STR
    Mem As String * LINEDEVCAPS_FIXEDSIZE
End Type

Global Const LINEDEVSTATE_OTHER = &H1&
Global Const LINEDEVSTATE_RINGING = &H2&
Global Const LINEDEVSTATE_CONNECTED = &H4&
Global Const LINEDEVSTATE_DISCONNECTED = &H8&
Global Const LINEDEVSTATE_MSGWAITON = &H10&
Global Const LINEDEVSTATE_MSGWAITOFF = &H20&
Global Const LINEDEVSTATE_INSERVICE = &H40&
Global Const LINEDEVSTATE_OUTOFSERVICE = &H80&
Global Const LINEDEVSTATE_MAINTENANCE = &H100&
Global Const LINEDEVSTATE_OPEN = &H200&
Global Const LINEDEVSTATE_CLOSE = &H400&
Global Const LINEDEVSTATE_NUMCALLS = &H800&
Global Const LINEDEVSTATE_NUMCOMPLETIONS = &H1000&
Global Const LINEDEVSTATE_TERMINALS = &H2000&
Global Const LINEDEVSTATE_ROAMMODE = &H4000&
Global Const LINEDEVSTATE_BATTERY = &H8000&
Global Const LINEDEVSTATE_SIGNAL = &H10000
Global Const LINEDEVSTATE_DEVSPECIFIC = &H20000
Global Const LINEDEVSTATE_REINIT = &H40000
Global Const LINEDEVSTATE_LOCK = &H80000

Type LINEDEVSTATUS
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwNumOpens As Long
    dwOpenMediaModes As Long
    dwNumActiveCalls As Long
    dwNumOnHoldCalls As Long
    dwNumOnHoldPendCalls As Long
    dwLineFeatures As Long
    dwNumCallCompletions As Long
    dwRingMode As Long
    dwSignalLevel As Long
    dwBatteryLevel As Long
    dwRoamMode As Long

    dwDevStatusFlags As Long

    dwTerminalModesSize As Long
    dwTerminalModesOffset As Long

    dwDevSpecificSize As Long
    dwDevSpecificOffset As Long
End Type
Global Const LINEDEVSTATUS_FIXEDSIZE = 76

Type LINEDEVSTATUS_STR
    Mem As String * LINEDEVSTATUS_FIXEDSIZE
End Type

Global Const LINEDEVSTATUSFLAGS_CONNECTED = &H1&
Global Const LINEDEVSTATUSFLAGS_MSGWAIT = &H2&
Global Const LINEDEVSTATUSFLAGS_INSERVICE = &H4&
Global Const LINEDEVSTATUSFLAGS_LOCKED = &H8&

Global Const LINEDIALTONEMODE_NORMAL = &H1&
Global Const LINEDIALTONEMODE_SPECIAL = &H2&
Global Const LINEDIALTONEMODE_INTERNAL = &H4&
Global Const LINEDIALTONEMODE_EXTERNAL = &H8&
Global Const LINEDIALTONEMODE_UNKNOWN = &H10&
Global Const LINEDIALTONEMODE_UNAVAIL = &H20&

Global Const LINEDIGITMODE_PULSE = &H1&
Global Const LINEDIGITMODE_DTMF = &H2&
Global Const LINEDIGITMODE_DTMFEND = &H4&

Global Const LINEDISCONNECTMODE_NORMAL = &H1&
Global Const LINEDISCONNECTMODE_UNKNOWN = &H2&
Global Const LINEDISCONNECTMODE_REJECT = &H4&
Global Const LINEDISCONNECTMODE_PICKUP = &H8&
Global Const LINEDISCONNECTMODE_FORWARDED = &H10&
Global Const LINEDISCONNECTMODE_BUSY = &H20&
Global Const LINEDISCONNECTMODE_NOANSWER = &H40&
Global Const LINEDISCONNECTMODE_BADADDRESS = &H80&
Global Const LINEDISCONNECTMODE_UNREACHABLE = &H100&
Global Const LINEDISCONNECTMODE_CONGESTION = &H200&
Global Const LINEDISCONNECTMODE_INCOMPATIBLE = &H400&
Global Const LINEDISCONNECTMODE_UNAVAIL = &H800&

Global Const LINEERR_ALLOCATED = &H80000001
Global Const LINEERR_BADDEVICEID = &H80000002
Global Const LINEERR_BEARERMODEUNAVAIL = &H80000003
Global Const LINEERR_CALLUNAVAIL = &H80000005
Global Const LINEERR_COMPLETIONOVERRUN = &H80000006
Global Const LINEERR_CONFERENCEFULL = &H80000007
Global Const LINEERR_DIALBILLING = &H80000008
Global Const LINEERR_DIALDIALTONE = &H80000009
Global Const LINEERR_DIALPROMPT = &H8000000A
Global Const LINEERR_DIALQUIET = &H8000000B
Global Const LINEERR_INCOMPATIBLEAPIVERSION = &H8000000C
Global Const LINEERR_INCOMPATIBLEEXTVERSION = &H8000000D
Global Const LINEERR_INIFILECORRUPT = &H8000000E
Global Const LINEERR_INUSE = &H8000000F
Global Const LINEERR_INVALADDRESS = &H80000010
Global Const LINEERR_INVALADDRESSID = &H80000011
Global Const LINEERR_INVALADDRESSMODE = &H80000012
Global Const LINEERR_INVALADDRESSSTATE = &H80000013
Global Const LINEERR_INVALAPPHANDLE = &H80000014
Global Const LINEERR_INVALAPPNAME = &H80000015
Global Const LINEERR_INVALBEARERMODE = &H80000016
Global Const LINEERR_INVALCALLCOMPLMODE = &H80000017
Global Const LINEERR_INVALCALLHANDLE = &H80000018
Global Const LINEERR_INVALCALLPARAMS = &H80000019
Global Const LINEERR_INVALCALLPRIVILEGE = &H8000001A
Global Const LINEERR_INVALCALLSELECT = &H8000001B
Global Const LINEERR_INVALCALLSTATE = &H8000001C
Global Const LINEERR_INVALCALLSTATELIST = &H8000001D
Global Const LINEERR_INVALCARD = &H8000001E
Global Const LINEERR_INVALCOMPLETIONID = &H8000001F
Global Const LINEERR_INVALCONFCALLHANDLE = &H80000020
Global Const LINEERR_INVALCONSULTCALLHANDLE = &H80000021
Global Const LINEERR_INVALCOUNTRYCODE = &H80000022
Global Const LINEERR_INVALDEVICECLASS = &H80000023
Global Const LINEERR_INVALDEVICEHANDLE = &H80000024
Global Const LINEERR_INVALDIGITLIST = &H80000026
Global Const LINEERR_INVALDIGITMODE = &H80000027
Global Const LINEERR_INVALDIGITS = &H80000028
Global Const LINEERR_INVALEXTVERSION = &H80000029
Global Const LINEERR_INVALGROUPID = &H8000002A
Global Const LINEERR_INVALLINEHANDLE = &H8000002B
Global Const LINEERR_INVALLINESTATE = &H8000002C
Global Const LINEERR_INVALLOCATION = &H8000002D
Global Const LINEERR_INVALMEDIALIST = &H8000002E
Global Const LINEERR_INVALMEDIAMODE = &H8000002F
Global Const LINEERR_INVALMESSAGEID = &H80000030
Global Const LINEERR_INVALPARAM = &H80000032
Global Const LINEERR_INVALPARKID = &H80000033
Global Const LINEERR_INVALPARKMODE = &H80000034
Global Const LINEERR_INVALPOINTER = &H80000035
Global Const LINEERR_INVALPRIVSELECT = &H80000036
Global Const LINEERR_INVALRATE = &H80000037
Global Const LINEERR_INVALREQUESTMODE = &H80000038
Global Const LINEERR_INVALTERMINALID = &H80000039
Global Const LINEERR_INVALTERMINALMODE = &H8000003A
Global Const LINEERR_INVALTIMEOUT = &H8000003B
Global Const LINEERR_INVALTONE = &H8000003C
Global Const LINEERR_INVALTONELIST = &H8000003D
Global Const LINEERR_INVALTONEMODE = &H8000003E
Global Const LINEERR_INVALTRANSFERMODE = &H8000003F
Global Const LINEERR_LINEMAPPERFAILED = &H80000040
Global Const LINEERR_NOCONFERENCE = &H80000041
Global Const LINEERR_NODEVICE = &H80000042
Global Const LINEERR_NODRIVER = &H80000043
Global Const LINEERR_NOMEM = &H80000044
Global Const LINEERR_NOREQUEST = &H80000045
Global Const LINEERR_NOTOWNER = &H80000046
Global Const LINEERR_NOTREGISTERED = &H80000047
Global Const LINEERR_OPERATIONFAILED = &H80000048
Global Const LINEERR_OPERATIONUNAVAIL = &H80000049
Global Const LINEERR_RATEUNAVAIL = &H8000004A
Global Const LINEERR_RESOURCEUNAVAIL = &H8000004B
Global Const LINEERR_REQUESTOVERRUN = &H8000004C
Global Const LINEERR_STRUCTURETOOSMALL = &H8000004D
Global Const LINEERR_TARGETNOTFOUND = &H8000004E
Global Const LINEERR_TARGETSELF = &H8000004F
Global Const LINEERR_UNINITIALIZED = &H80000050
Global Const LINEERR_USERUSERINFOTOOBIG = &H80000051
Global Const LINEERR_REINIT = &H80000052
Global Const LINEERR_ADDRESSBLOCKED = &H80000053
Global Const LINEERR_BILLINGREJECTED = &H80000054
Global Const LINEERR_INVALFEATURE = &H80000055
Global Const LINEERR_NOMULTIPLEINSTANCE = &H80000056

Global Const LINEFEATURE_DEVSPECIFIC = &H1&
Global Const LINEFEATURE_DEVSPECIFICFEAT = &H2&
Global Const LINEFEATURE_FORWARD = &H4&
Global Const LINEFEATURE_MAKECALL = &H8&
Global Const LINEFEATURE_SETMEDIACONTROL = &H10&
Global Const LINEFEATURE_SETTERMINAL = &H20&

Type lineForward
    dwForwardMode As Long

    dwCallerAddressSize As Long
    dwCallerAddressOffset As Long

    dwDestCountryCode As Long
    dwDestAddressSize As Long
    dwDestAddressOffset As Long
End Type
Global Const LINEFORWARD_FIXEDSIZE = 24

Type LINEFORWARD_STR
    Mem As String * LINEFORWARD_FIXEDSIZE
End Type

Type LINEFORWARDLIST
    dwTotalSize As Long
    dwNumEntries As Long
End Type
Global Const LINEFORWARDLIST_FIXEDSIZE = 8

Type LINEFORWARDLIST_STR
    Mem As String * LINEFORWARDLIST_FIXEDSIZE
End Type

Global Const LINEFORWARDMODE_UNCOND = &H1&
Global Const LINEFORWARDMODE_UNCONDINTERNAL = &H2&
Global Const LINEFORWARDMODE_UNCONDEXTERNAL = &H4&
Global Const LINEFORWARDMODE_UNCONDSPECIFIC = &H8&
Global Const LINEFORWARDMODE_BUSY = &H10&
Global Const LINEFORWARDMODE_BUSYINTERNAL = &H20&
Global Const LINEFORWARDMODE_BUSYEXTERNAL = &H40&
Global Const LINEFORWARDMODE_BUSYSPECIFIC = &H80&
Global Const LINEFORWARDMODE_NOANSW = &H100&
Global Const LINEFORWARDMODE_NOANSWINTERNAL = &H200&
Global Const LINEFORWARDMODE_NOANSWEXTERNAL = &H400&
Global Const LINEFORWARDMODE_NOANSWSPECIFIC = &H800&
Global Const LINEFORWARDMODE_BUSYNA = &H1000&
Global Const LINEFORWARDMODE_BUSYNAINTERNAL = &H2000&
Global Const LINEFORWARDMODE_BUSYNAEXTERNAL = &H4000&
Global Const LINEFORWARDMODE_BUSYNASPECIFIC = &H8000&

Global Const LINEGATHERTERM_BUFFERFULL = &H1&
Global Const LINEGATHERTERM_TERMDIGIT = &H2&
Global Const LINEGATHERTERM_FIRSTTIMEOUT = &H4&
Global Const LINEGATHERTERM_INTERTIMEOUT = &H8&
Global Const LINEGATHERTERM_CANCEL = &H10&

Global Const LINEGENERATETERM_DONE = &H1&
Global Const LINEGENERATETERM_CANCEL = &H2&

' This type is named differently than in TAPI.H because of the conflict with the function of the same name

Type LINEGENERATETONE_TYPE
    dwFrequency As Long
    dwCadenceOn As Long
    dwCadenceOff As Long
    dwVolume As Long
End Type
Global Const LINEGENERATETONE_FIXEDSIZE = 16

Type LINEGENERATETONE_STR
    Mem As String * LINEGENERATETONE_FIXEDSIZE
End Type

Global Const LINEMAPPER = &HFFFF

Type LINEMEDIACONTROLCALLSTATE
    dwCallStates As Long
    dwMediaControl As Long
End Type
Global Const LINEMEDIACONTROLCALLSTATE_FIXEDSIZE = 8

Type LINEMEDIACONTROLCALLSTATE_STR
    Mem As String * LINEMEDIACONTROLCALLSTATE_FIXEDSIZE
End Type

Type LINEMEDIACONTROLDIGIT
    dwDigit As Long
    dwDigitModes As Long
    dwMediaControl As Long
End Type
Global Const LINEMEDIACONTROLDIGIT_FIXEDSIZE = 12

Type LINEMEDIACONTROLDIGIT_STR
    Mem As String * LINEMEDIACONTROLDIGIT_FIXEDSIZE
End Type

Type LINEMEDIACONTROLMEDIA
    dwMediaModes As Long
    dwDuration As Long
    dwMediaControl As Long
End Type
Global Const LINEMEDIACONTROLMEDIA_FIXEDSIZE = 12

Type LINEMEDIACONTROLMEDIA_STR
    Mem As String * LINEMEDIACONTROLMEDIA_FIXEDSIZE
End Type

Type LINEMEDIACONTROLTONE
    dwAppSpecific As Long
    dwDuration As Long
    dwFrequency1 As Long
    dwFrequency2 As Long
    dwFrequency3 As Long
    dwMediaControl As Long
End Type
Global Const LINEMEDIACONTROLTONE_FIXEDSIZE = 24

Type LINEMEDIACONTROLTONE_STR
    Mem As String * LINEMEDIACONTROLTONE_FIXEDSIZE
End Type

Global Const LINEMEDIACONTROL_NONE = &H1&
Global Const LINEMEDIACONTROL_START = &H2&
Global Const LINEMEDIACONTROL_RESET = &H4&
Global Const LINEMEDIACONTROL_PAUSE = &H8&
Global Const LINEMEDIACONTROL_RESUME = &H10&
Global Const LINEMEDIACONTROL_RATEUP = &H20&
Global Const LINEMEDIACONTROL_RATEDOWN = &H40&
Global Const LINEMEDIACONTROL_RATENORMAL = &H80&
Global Const LINEMEDIACONTROL_VOLUMEUP = &H100&
Global Const LINEMEDIACONTROL_VOLUMEDOWN = &H200&
Global Const LINEMEDIACONTROL_VOLUMENORMAL = &H400&

Global Const LINEMEDIAMODE_UNKNOWN = &H2&
Global Const LINEMEDIAMODE_INTERACTIVEVOICE = &H4&
Global Const LINEMEDIAMODE_AUTOMATEDVOICE = &H8&
Global Const LINEMEDIAMODE_DATAMODEM = &H10&
Global Const LINEMEDIAMODE_G3FAX = &H20&
Global Const LINEMEDIAMODE_TDD = &H40&
Global Const LINEMEDIAMODE_G4FAX = &H80&
Global Const LINEMEDIAMODE_DIGITALDATA = &H100&
Global Const LINEMEDIAMODE_TELETEX = &H200&
Global Const LINEMEDIAMODE_VIDEOTEX = &H400&
Global Const LINEMEDIAMODE_TELEX = &H800&
Global Const LINEMEDIAMODE_MIXED = &H1000&
Global Const LINEMEDIAMODE_ADSI = &H2000&

Type LINEMONITORTONE
    dwAppSpecific As Long
    dwDuration As Long
    dwFrequency1 As Long
    dwFrequency2 As Long
    dwFrequency3 As Long
End Type
Global Const LINEMONITORTONE_FIXEDSIZE = 20

Type LINEMONITORTONE_STR
    Mem As String * LINEMONITORTONE_FIXEDSIZE
End Type

Global Const LINEPARKMODE_DIRECTED = &H1&
Global Const LINEPARKMODE_NONDIRECTED = &H2&

Global Const LINEREMOVEFROMCONF_NONE = &H1&
Global Const LINEREMOVEFROMCONF_LAST = &H2&
Global Const LINEREMOVEFROMCONF_ANY = &H3&

Type LINEREQMAKECALL
    szDestAddress As String * TAPIMAXDESTADDRESSSIZE
    szAppName As String * TAPIMAXAPPNAMESIZE
    szCalledParty As String * TAPIMAXCALLEDPARTYSIZE
    szComment As String * TAPIMAXCOMMENTSIZE
End Type
Global Const LINEREQMAKECALL_FIXEDSIZE = TAPIMAXDESTADDRESSSIZE + TAPIMAXAPPNAMESIZE + TAPIMAXCALLEDPARTYSIZE + TAPIMAXCOMMENTSIZE

Type LINEREQMAKECALL_STR
    Mem As String * LINEREQMAKECALL_FIXEDSIZE
End Type

Type LINEREQMEDIACALL
    hWnd As Integer
    wRequestID As Integer
    szDeviceClass As String * TAPIMAXDEVICECLASSSIZE
    ucDeviceID As String * TAPIMAXDEVICEIDSIZE
    dwSize As Long
    dwSecure As Long
    szDestAddress As String * TAPIMAXDESTADDRESSSIZE
    szAppName As String * TAPIMAXAPPNAMESIZE
    szCalledParty As String * TAPIMAXCALLEDPARTYSIZE
    szComment As String * TAPIMAXCOMMENTSIZE
End Type
Global Const LINEREQMEDIACALL_FIXEDSIZE = 12 + TAPIMAXDEVICECLASSSIZE + TAPIMAXDEVICEIDSIZE + TAPIMAXDESTADDRESSSIZE + TAPIMAXAPPNAMESIZE + TAPIMAXCALLEDPARTYSIZE + TAPIMAXCOMMENTSIZE

Type LINEREQMEDIACALL_STR
    Mem As String * LINEREQMEDIACALL_FIXEDSIZE
End Type

Global Const LINEREQUESTMODE_MAKECALL = &H1&
Global Const LINEREQUESTMODE_MEDIACALL = &H2&
Global Const LINEREQUESTMODE_DROP = &H4&

Global Const LINEROAMMODE_UNKNOWN = &H1&
Global Const LINEROAMMODE_UNAVAIL = &H2&
Global Const LINEROAMMODE_HOME = &H4&
Global Const LINEROAMMODE_ROAMA = &H8&
Global Const LINEROAMMODE_ROAMB = &H10&

Global Const LINESPECIALINFO_NOCIRCUIT = &H1&
Global Const LINESPECIALINFO_CUSTIRREG = &H2&
Global Const LINESPECIALINFO_REORDER = &H4&
Global Const LINESPECIALINFO_UNKNOWN = &H8&
Global Const LINESPECIALINFO_UNAVAIL = &H10&

Type LINETERMCAPS
    dwTermDev As Long
    dwTermModes As Long
    dwTermSharing As Long
End Type
Global Const LINETERMCAPS_FIXEDSIZE = 12

Type LINETERMCAPS_STR
    Mem As String * LINETERMCAPS_FIXEDSIZE
End Type

Global Const LINETERMDEV_PHONE = &H1&
Global Const LINETERMDEV_HEADSET = &H2&
Global Const LINETERMDEV_SPEAKER = &H4&

Global Const LINETERMMODE_BUTTONS = &H1&
Global Const LINETERMMODE_LAMPS = &H2&
Global Const LINETERMMODE_DISPLAY = &H4&
Global Const LINETERMMODE_RINGER = &H8&
Global Const LINETERMMODE_HOOKSWITCH = &H10&
Global Const LINETERMMODE_MEDIATOLINE = &H20&
Global Const LINETERMMODE_MEDIAFROMLINE = &H40&
Global Const LINETERMMODE_MEDIABIDIRECT = &H80&

Global Const LINETERMSHARING_PRIVATE = &H1&
Global Const LINETERMSHARING_SHAREDEXCL = &H2&
Global Const LINETERMSHARING_SHAREDCONF = &H4&

Global Const LINETONEMODE_CUSTOM = &H1&
Global Const LINETONEMODE_RINGBACK = &H2&
Global Const LINETONEMODE_BUSY = &H4&
Global Const LINETONEMODE_BEEP = &H8&
Global Const LINETONEMODE_BILLING = &H10&

Global Const LINETRANSFERMODE_TRANSFER = &H1&
Global Const LINETRANSFERMODE_CONFERENCE = &H2&

Type LINETRANSLATEOUTPUT
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwDialableStringSize As Long
    dwDialableStringOffset As Long
    dwDisplayableStringSize As Long
    dwDisplayableStringOffset As Long

    dwCurrentCountry As Long
    dwDestCountry As Long
    dwTranslateResults As Long
End Type
Global Const LINETRANSLATEOUTPUT_FIXEDSIZE = 40

Type LINETRANSLATEOUTPUT_STR
    Mem As String * LINETRANSLATEOUTPUT_FIXEDSIZE
End Type

Type LINETRANSLATECAPS
    dwTotalSize As Long
    dwNeededSize As Long
    dwUsedSize As Long

    dwNumLocations As Long
    dwLocationListSize As Long
    dwLocationListOffset As Long

    dwCurrentLocationID As Long

    dwNumCards As Long
    dwCardListSize As Long
    dwCardListOffset As Long

    dwCurrentPreferredCardID As Long
End Type
Global Const LINETRANSLATECAPS_FIXEDSIZE = 44

Type LINETRANSLATECAPS_STR
    Mem As String * LINETRANSLATECAPS_FIXEDSIZE
End Type

Type LINELOCATIONENTRY
    dwPermanentLocationID As Long
    dwLocationNameSize As Long
    dwLocationNameOffset As Long
    dwCountryCode As Long
    dwCityCodeSize As Long
    dwCityCodeOffset As Long
    dwPreferredCardID As Long
End Type
Global Const LINELOCATIONENTRY_FIXEDSIZE = 28

Type LINELOCATIONENTRY_STR
    Mem As String * LINELOCATIONENTRY_FIXEDSIZE
End Type

Type LINECARDENTRY
    dwPermanentCardID As Long
    dwCardNameSize As Long
    dwCardNameOffset As Long
End Type
Global Const LINECARDENTRY_FIXEDSIZE = 12

Type LINECARDENTRY_STR
    Mem As String * LINECARDENTRY_FIXEDSIZE
End Type

Global Const LINETOLLLISTOPTION_ADD = &H1&
Global Const LINETOLLLISTOPTION_REMOVE = &H2&

Global Const LINETRANSLATEOPTION_CARDOVERRIDE = &H1&

Global Const LINETRANSLATERESULT_CANONICAL = &H1&
Global Const LINETRANSLATERESULT_INTERNATIONAL = &H2&
Global Const LINETRANSLATERESULT_LONGDISTANCE = &H4&
Global Const LINETRANSLATERESULT_LOCAL = &H8&
Global Const LINETRANSLATERESULT_INTOLLLIST = &H10&
Global Const LINETRANSLATERESULT_NOTINTOLLLIST = &H20&
Global Const LINETRANSLATERESULT_DIALBILLING = &H40&
Global Const LINETRANSLATERESULT_DIALQUIET = &H80&
Global Const LINETRANSLATERESULT_DIALDIALTONE = &H100&
Global Const LINETRANSLATERESULT_DIALPROMPT = &H200&

