Attribute VB_Name = "LibMAPIErr"
Option Explicit

Public Function MAPIErr(lError) As String
    '
    ' return displayable string for error
    '
    Dim cRtn As String
    '
    Select Case lError
        Case MAPI_USER_ABORT ' 1
            cRtn = "MAPI User Cancel"
        Case MAPI_E_FAILURE ' 2
            cRtn = "MAPI Failure"
        Case MAPI_E_LOGIN_FAILURE ' 3
            cRtn = "MAPI Login failure"
        Case MAPI_E_DISK_FULL ' 4
            cRtn = "MAPI Disk full"
        Case MAPI_E_INSUFFICIENT_MEMORY ' 5
            cRtn = "MAPI Insufficient memory"
        Case MAPI_E_BLK_TOO_SMALL ' 6
            cRtn = "MAPI Block too small"
        Case MAPI_E_TOO_MANY_SESSIONS ' 8
            cRtn = "MAPI Too many sessions"
        Case MAPI_E_TOO_MANY_FILES ' 9
            cRtn = "MAPI too many files"
        Case MAPI_E_TOO_MANY_RECIPIENTS ' 10
            cRtn = "MAPI Too many attachments"
        Case MAPI_E_ATTACHMENT_NOT_FOUND ' 11
            cRtn = "MAPI Attachment not found"
        Case MAPI_E_ATTACHMENT_OPEN_FAILURE ' 12
            cRtn = "MAPI Attachment open failure"
        Case MAPI_E_ATTACHMENT_WRITE_FAILURE ' 13
            cRtn = "MAPI Attachment Write Failure"
        Case MAPI_E_UNKNOWN_RECIPIENT ' 14
            cRtn = "MAPI Unknown recipient"
        Case MAPI_E_BAD_RECIPTYPE ' 15
            cRtn = "MAPI Bad recipient type"
        Case MAPI_E_NO_MESSAGES ' 16
            cRtn = "MAPI No messages"
        Case MAPI_E_INVALID_MESSAGE ' 17
            cRtn = "MAPI Invalid message"
        Case MAPI_E_TEXT_TOO_LARGE ' 18
            cRtn = "MAPI Text too large"
        Case MAPI_E_INVALID_SESSION ' 19
            cRtn = "MAPI Invalid session"
        Case MAPI_E_TYPE_NOT_SUPPORTED ' 20
            cRtn = "MAPI Type not supported"
        Case MAPI_E_AMBIGUOUS_RECIPIENT ' 21
            cRtn = "MAPI Ambiguous recipient"
        Case MAPI_E_MESSAGE_IN_USE ' 22
            cRtn = "MAPI Message in use"
        Case MAPI_E_NETWORK_FAILURE ' 23
            cRtn = "MAPI Network failure"
        Case MAPI_E_INVALID_EDITFIELDS ' 24
            cRtn = "MAPI Invalid edit fields"
        Case MAPI_E_INVALID_RECIPS ' 25
            cRtn = "MAPI Invalid Recipients"
        Case MAPI_E_NOT_SUPPORTED ' 26
            cRtn = "MAPI Not supported"
        Case MAPI_E_NO_LIBRARY ' 999
            cRtn = "MAPI No Library"
        Case MAPI_E_INVALID_PARAMETER ' 998
            cRtn = "MAPI Invalid parameter"
    End Select
    '
    MAPIErr = cRtn & " [" & CStr(lError) & "]"
    '
End Function

