Attribute VB_Name = "LibVPhone"
Option Explicit
'
' establish voice command objects
Public objVCmd As Object
Public objVMenu As Object
Public lVMenuIdx As Long
Public objVText As Object
Public iVType As Integer
Public cUserMsgs() As String
'
Public Const ttsHello = 0
Public Const ttsVPhone = 1
Public Const ttsList = 2
Public Const ttsExit = 3
Public Const ttsEdit = 4
'
' database objects
Public wsPhone As Workspace
Public dbPhone As Database
Public rsPhone As Recordset

Public Sub BuildVMenu()
    '
    ' build a voice menu
    '
    Dim iType As Integer
    Dim cState As String
    Dim lLangId As Long
    Dim cDialect As String
    Dim cAppName As String
    Dim cVMenu(3) As String
    Dim x As Integer
    '
    ' set params
    cAppName = App.EXEName
    cState = "Voice Phone"
    cDialect = ""
    lLangId = 1033
    iType = vcmdmc_CREATE_TEMP
    '
    ' set menu commands
    cVMenu(1) = "New Record"
    cVMenu(2) = "Place Call"
    cVMenu(3) = "Exit"
    '
    ' now instance menu
    Set objVMenu = objVCmd.MenuCreate( _
        cAppName, cState, lLangId, cDialect, iType)
    '
    ' add simple commands to menu
    For x = 1 To 3
        lVMenuIdx = lVMenuIdx + 1
        objVMenu.Add lVMenuIdx, cVMenu(x), "Voice Phone Commands", "Voice Phone Commands"
    Next x
    
    '
    ' create list commands
    lVMenuIdx = lVMenuIdx + 1
    objVMenu.Add lVMenuIdx, "Edit <Name>", "Edit Name", "Edit Name"
    '
    lVMenuIdx = lVMenuIdx + 1
    objVMenu.Add lVMenuIdx, "Delete <Name>", "Delete Name", "Delete Name"
    '
    lVMenuIdx = lVMenuIdx + 1
    objVMenu.Add lVMenuIdx, "Dial <Name>", "Dial Name", "Dial Name"
    '
    lVMenuIdx = lVMenuIdx + 1
    objVMenu.Add lVMenuIdx, "Find <Name>", "Find Name", "Find Name"
    '
    
End Sub

Public Sub LoadNameList()
    '
    ' fill list of names for vCmd
    '
    Dim cNameList As String
    Dim iNameCount As String
    '
    cNameList = ""
    iNameCount = 0
    rsPhone.MoveFirst
    Do Until rsPhone.EOF
        cNameList = cNameList & rsPhone.Fields("Name") & Chr(0)
        iNameCount = iNameCount + 1
        rsPhone.MoveNext
    Loop
    '
    objVMenu.ListSet "Name", iNameCount, cNameList
    '
End Sub

Public Sub InitVCmd()
    '
    ' init voice command
    Set objVCmd = CreateObject("Speech.VoiceCommand")
    objVCmd.Register ""
    objVCmd.Awake = True
    objVCmd.Callback = App.EXEName & ".SRCallBack"
    '
    ' init voice menu
    BuildVMenu
    objVMenu.Active = True
    '
End Sub

Public Sub InitVTxt()
    '
    ' init voice text
    Set objVText = CreateObject("Speech.VoiceText")
    objVText.Register "", App.EXEName
    objVText.Enabled = True
    objVText.Callback = App.EXEName & ".TTSCallBack"
    '
End Sub

Public Function LookUp(cName As String) As String
    '
    ' lookup a name in the list
    ' return the phone number
    '
    Dim cRtn As String
    '
    cName = Trim(cName)
    rsPhone.FindFirst "Name = '" & cName & "'"
    If rsPhone.NoMatch = True Then
        cRtn = ""
    Else
        cRtn = rsPhone.Fields("Phone").Value
    End If
    '
    LookUp = cRtn
    '
End Function

Public Sub BuildDatabase()
    '
    ' build new database
    '
    On Error GoTo LocalErr
    '
    Dim ws As Workspace
    Dim db As Database
    Dim cSQL(3) As String
    Dim x As Integer
    '
    cSQL(1) = "CREATE TABLE VPHONE (Name TEXT(20),Phone TEXT(20));"
    cSQL(2) = "INSERT INTO VPHONE VALUES ('Information','1-555-1212');"
    cSQL(3) = "INSERT INTO VPHONE VALUES('SAMS Publishing','1-800-428-5331');"
    '
    Set ws = DBEngine.Workspaces(0)
    Set db = CreateDatabase(App.Path & "\VPHONE.MDB", dbLangGeneral)
    '
    For x = 1 To 3
        db.Execute cSQL(x), dbFailOnError
    Next x
    '
    db.Close
    Set db = Nothing
    Set ws = Nothing
    '
    Exit Sub
    '
LocalErr:
    MsgBox Err.Description & Chr(13) & Err.Source, vbCritical, "BuildDatabase"
    '
End Sub

Public Sub OpenDatabase()
    '
    ' open phone database
    '
    On Error GoTo LocalErr
    '
    Dim cSelect As String
    '
    cSelect = "SELECT * FROM VPHONE"
    '
    Set wsPhone = DBEngine.Workspaces(0)
    Set dbPhone = wsPhone.OpenDatabase(App.Path & "\VPHONE.MDB")
    Set rsPhone = dbPhone.OpenRecordset(cSelect, dbOpenDynaset)
    '
    Exit Sub
    '
LocalErr:
    MsgBox Err.Description & Chr(13) & Err.Source, vbCritical, "OpenDatabase"
    '
End Sub

Public Sub InitDB()
    '
    ' set up db stuff
    '
    Dim cDBName As String
    cDBName = App.Path & "\VPHONE.MDB"
    On Error Resume Next
    Open cDBName For Input As 1
    If Err <> 0 Then
        Close 1
        BuildDatabase
    Else
        Close 1
    End If
    On Error GoTo 0
    '
    OpenDatabase
    '
End Sub

Public Sub DeleteRec(cName As String)
    '
    ' delete record from table
    '
    Dim iAns As Integer
    '
    cName = Trim(cName)
    iAns = MsgBox(cName, vbExclamation + vbYesNo, "Delete Record")
    If iAns = vbYes Then
        rsPhone.FindFirst "Name = '" & cName & "'"
        If rsPhone.NoMatch = False Then
            rsPhone.Delete
        End If
    End If
    '
End Sub

Public Sub EditRec(cName As String)
    '
    ' edit an existing record
    '
    Dim iAns As Integer
    '
    cName = Trim(cName)
    rsPhone.FindFirst "Name='" & cName & "'"
    If rsPhone.NoMatch = False Then
        Load frmVRec
        frmVRec.txtName = rsPhone.Fields("Name")
        frmVRec.txtPhone = rsPhone.Fields("Phone")
        frmVRec.lblaction = "EDIT"
        frmVRec.Show vbModal
    End If
    '
End Sub

Public Sub AddRec()
    '
    ' add a new record
    '
    Load frmVRec
    frmVRec.txtName = ""
    frmVRec.txtPhone = ""
    frmVRec.lblaction = "ADD"
    frmVRec.Show vbModal
    '
End Sub

Public Sub PlaceCall(cPhone As String, cName As String)
    '
    Dim tCall As TAPICall
    Dim lRtn As Long
    '
    If Trim(cPhone) <> "" Then
        tCall.Address = cPhone
        tCall.AppName = App.EXEName
        tCall.CalledParty = cName
        tCall.Comment = ""
        lRtn = TAPIMakeCall(tCall)
        If lRtn < 0 Then
            MsgBox lRtn
        End If
    End If
    '
End Sub

Public Sub LoadMsgs()
    '
    ' build a list of user messages
    '
    ReDim cUserMsgs(5)
    '
    cUserMsgs(0) = "Hello. Welcome to Voice Phone."
    cUserMsgs(1) = "Press New, Edit, or Delete to modify the phone list."
    cUserMsgs(2) = "Select a name from the list and press Place Call to dial the phone."
    cUserMsgs(3) = "Press Exit to end this program."
    cUserMsgs(4) = "Enter name and phone number, then press OK or cancel."
    '
End Sub

Public Sub CenterForm(frm As Form)
    '
    frm.Left = (Screen.Width - frm.Width) / 2
    frm.Top = (Screen.Height - frm.Height) / 2
    '
End Sub
