Attribute VB_Name = "AsisstedTAPI"
Option Explicit

'
' declare assisted tapi functions
'
#If Win32 Then
    Declare Function tapiRequestMakeCall Lib "TAPI32.DLL" (ByVal lpszDestAddress As String, ByVal lpszAppName As String, ByVal lpszCalledParty As String, ByVal lpszComment As String) As Long
    Declare Function tapiGetLocationInfo Lib "TAPI32.DLL" (ByVal lpszCountryCode As String, ByVal lpszCityCode As String) As Long
#Else
    Declare Function tapiRequestMakeCall Lib "TAPI.DLL" (ByVal lpszDestAddress As String, ByVal lpszAppName As String, ByVal lpszCalledParty As String, ByVal lpszComment As String) As Long
    Declare Function tapiGetLocationInfo Lib "TAPI.DLL" (ByVal lpszCountryCode As String, ByVal lpszCityCode As String) As Long
#End If

'
' TAPILocation Type
Type TAPILocation
    Country As String * 1
    City As String * 3
End Type
'
' TAPIMakeCall Type
Type TAPICall
    Address As String
    AppName As String
    CalledParty As String
    Comment As String
End Type
    

Public Function TAPIGetLocation() As TAPILocation
    '
    ' returns UDT w/ city and country
    '
    Dim lTapi As Long
    Dim cCountry As String * 1
    Dim cCity As String * 3
    '
    lTapi = tapiGetLocationInfo(cCountry, cCity)
    If lTapi >= 0 Then
        TAPIGetLocation.Country = cCountry
        TAPIGetLocation.City = cCity
    End If
    '
End Function

Public Function TAPIMakeCall(tapiRec As TAPICall) As Long
    '
    ' make an assisted TAPI call
    ' returns 0 if OK, <0 if error
    '
    TAPIMakeCall = tapiRequestMakeCall(tapiRec.Address, tapiRec.AppName, tapiRec.CalledParty, tapiRec.Comment)
    '
End Function
